#define SCR_W       640 //400
#define SCR_H       480 //300
#define WIN         1   //0
#define SCORETBFILE "scoretb.dat"
#define VER         "1.02"

#include "game.h"

void LoadData(int fl)
 {
  int st,h;

  if(fl==-3) // End
   {
    bg=load_bmp("data/video/final.bmp",pal);
    for(int i=0;i<8;i++) intro[0].frame[i]=create_sub_bitmap(bg,320+i*29,28,28,48);
    intro[0].frame[8]=create_sub_bitmap(bg,381,0,53,15);
    intro[0].frame[9]=create_sub_bitmap(bg,435,0,53,15);

    intro[5].frame[0]=create_sub_bitmap(bg,320,174,20,17);
    intro[5].frame[1]=create_sub_bitmap(bg,341,174,20,17);

    intro[1].frame[0]=create_sub_bitmap(bg,320,0,60,27);
    intro[2].frame[0]=create_sub_bitmap(bg,320,77,70,96);
    intro[3].frame[0]=create_sub_bitmap(bg,320,224,19,19);
    intro[3].frame[1]=create_sub_bitmap(bg,320,174,33,49);
    for(int i=0;i<4;i++) intro[4].frame[i]=create_sub_bitmap(bg,391+i*61,77,60,60);
    for(int i=0;i<4;i++) intro[4].frame[4+i]=create_sub_bitmap(bg,391+i*61,138,60,60);
    
    pl_fx[0]=load_sample("data/audio/boom2.wav");
    fade_out(5);
    return;
   }  
  if(fl==-2) // Intro
   {
    bg=load_bmp("data/video/intro.bmp",pal);
    bgsound=load_midi("data/audio/bgsound.mid");
    for(int i=0;i<7;i++) intro[0].frame[i]=create_sub_bitmap(bg,320+i*29,28,28,48);
    intro[1].frame[0]=create_sub_bitmap(bg,320,0,60,27);
    intro[2].frame[0]=create_sub_bitmap(bg,320,77,70,96);
    intro[3].frame[0]=create_sub_bitmap(bg,320,224,19,19);
    intro[3].frame[1]=create_sub_bitmap(bg,320,174,33,49);
    for(int i=0;i<4;i++) intro[4].frame[i]=create_sub_bitmap(bg,391+i*61,77,60,60);
    for(int i=0;i<4;i++) intro[4].frame[4+i]=create_sub_bitmap(bg,391+i*61,138,60,60);
    
    pl_fx[0]=load_sample("data/audio/fire1.wav");
    pl_fx[1]=load_sample("data/audio/boom2.wav");
    pl_fx[2]=load_sample("data/audio/fiii1.wav");
    fade_out(5);
    return;
   }  
  if(fl==-1) // Shop
   {
    bg=load_bmp("data/video/shop.bmp",pal);
    //set_palette(pal);
    shop[0]=create_sub_bitmap(bg,320,0,27,26);
    shop[1]=create_sub_bitmap(bg,320+28,0,27,26);
    shop[2]=create_sub_bitmap(bg,320+28+28,0,27,26);
    shop[3]=create_sub_bitmap(bg,320+28+28+28,0,27,26);    
    shop[4]=create_sub_bitmap(bg,320,40,31,18);
    shop[5]=create_sub_bitmap(bg,352,40,31,18);
    shop[6]=create_sub_bitmap(bg,384,40,31,18);
    fade_out(5);
    return;
   }
  if(fl==0) // Titoli
   {
   	pl_fx[2]=load_sample("data/audio/bell1.wav");
    bg=load_bmp("data/video/title.bmp",pal);
    fade_out(5);
    return;
   }
  if(fl==1) // Scena 1
   {
    bg=load_bmp("data/video/stage1.bmp",pal);
    bgcol=6; txcol=9; swcol=178;
    anim[0].frame[0]=create_sub_bitmap(bg,263+38,0,18,18);
    anim[0].frame[1]=create_sub_bitmap(bg,263+19,0,18,18);
    anim[0].frame[2]=create_sub_bitmap(bg,263   ,0,18,18);
    anim[0].actfr=0; anim[0].maxfr=3;
    for(int i=0;i<4;i++) boss.frame[i]=create_sub_bitmap(bg,50*i+i,0,50,84);
    boss_bomb[0].frame[0]=create_sub_bitmap(bg,204,0,3,29);
    boss_bomb[1].frame[0]=create_sub_bitmap(bg,204,0,3,29);
    boss_bomb[2].frame[0]=create_sub_bitmap(bg,208,0,7,29);
    boss_bomb[3].frame[0]=create_sub_bitmap(bg,216,0,4,29);
    boss_bomb[4].frame[0]=create_sub_bitmap(bg,216,0,4,29);
   }
  if(fl==2) // Scena 2
   {
    bg=load_bmp("data/video/stage2.bmp",pal);
    bgcol=4; txcol=6; swcol=36;
    anim[0].frame[0]=create_sub_bitmap(bg,308   ,0,11,19);
    anim[0].frame[1]=create_sub_bitmap(bg,308-12,0,11,19);
    anim[0].frame[2]=create_sub_bitmap(bg,308-24,0,11,19);
    anim[0].frame[3]=create_sub_bitmap(bg,308-36,0,11,19);
    anim[0].actfr=0; anim[0].maxfr=4;
    for(int i=0;i<4;i++) anim[1].frame[i]=create_sub_bitmap(bg,228,13*i+i,16,13);
    anim[1].actfr=0; anim[1].maxfr=4;
    for(int i=0;i<4;i++) boss.frame[i]=create_sub_bitmap(bg,39*i+i,0,39,54);
    for(int i=0;i<4;i++) boss1.frame[i]=create_sub_bitmap(bg,160,17*i+i,30,17);
    for(int i=0;i<4;i++) boss1.frame[i+4]=create_sub_bitmap(bg,197,17*i+i,30,17);
    boss_bomb[0].frame[0]=create_sub_bitmap(bg,191,0,5,17);
    boss_bomb[1].frame[0]=create_sub_bitmap(bg,191,0,5,17);
    boss_bomb[2].frame[0]=create_sub_bitmap(bg,191,0,5,17);
    boss_bomb[3].frame[0]=create_sub_bitmap(bg,191,0,5,17);
    boss_bomb[4].frame[0]=create_sub_bitmap(bg,191,0,5,17);
    boss_bomb[5].frame[0]=create_sub_bitmap(bg,191,0,5,17);
   }
  if(fl==3) // Scena 3
   {
    bg=load_bmp("data/video/stage3.bmp",pal);
    bgcol=1; txcol=3;
    for(int i=0;i<2;i++) boss.frame[i]  =create_sub_bitmap(bg,63*i+i,0,63,29);
    for(int i=0;i<2;i++) boss.frame[i+2]=create_sub_bitmap(bg,63*i+i,30,63,29);
    boss_bomb[0].frame[0]=create_sub_bitmap(bg,128,0,16,25);
    boss_bomb[0].frame[1]=create_sub_bitmap(bg,145,0,16,25);
    boss_bomb[1].frame[0]=create_sub_bitmap(bg,128,0,16,25);
    boss_bomb[1].frame[1]=create_sub_bitmap(bg,145,0,16,25);
    boss_bomb[2].frame[0]=create_sub_bitmap(bg,128,0,16,25);
    boss_bomb[2].frame[1]=create_sub_bitmap(bg,145,0,16,25);
    boss_bomb[3].frame[0]=create_sub_bitmap(bg,128,0,16,25);
    boss_bomb[3].frame[1]=create_sub_bitmap(bg,145,0,16,25);
    boss1.frame[0]=create_sub_bitmap(bg,176,0,13,19);
    boss2.frame[0]=create_sub_bitmap(bg,176,0,13,19);
    boss3.frame[0]=create_sub_bitmap(bg,176,0,13,19);
    boss4.frame[0]=create_sub_bitmap(bg,162,0,13,19);
   }
  if(fl==4) // Scena 4
   {
    bg=load_bmp("data/video/stage4.bmp",pal);
    bgcol=1; txcol=4;
    for(int i=0;i<4;i++) boss.frame[i]=create_sub_bitmap(bg,76*i+i,0,76,58);
    boss_bomb[0].frame[0]=create_sub_bitmap(bg,231,0,13,22);
    boss_bomb[1].frame[0]=create_sub_bitmap(bg,245,0,5,5);
    boss_bomb[2].frame[0]=create_sub_bitmap(bg,245,0,5,5);
    boss_bomb[3].frame[0]=create_sub_bitmap(bg,245,0,5,5);
    boss_bomb[4].frame[0]=create_sub_bitmap(bg,245,0,5,5);
    boss_bomb[5].frame[0]=create_sub_bitmap(bg,245,0,5,5);
   }
  if(fl==5) // Scena 5
   {
    bg=load_bmp("data/video/stage5.bmp",pal);
    bgcol=1; txcol=4; swcol=77;
    for(int i=0;i<2;i++) boss.frame[i]  =create_sub_bitmap(bg,96*i+i,0,96,32);
    for(int i=0;i<1;i++) boss.frame[i+2]=create_sub_bitmap(bg,33*i+i,33,96,32);
    boss_bomb[0].frame[0]=create_sub_bitmap(bg,194,0,5,5);
    boss_bomb[1].frame[0]=create_sub_bitmap(bg,194,0,5,5);
    boss_bomb[2].frame[0]=create_sub_bitmap(bg,194,0,5,5);
    boss_bomb[3].frame[0]=create_sub_bitmap(bg,194,0,5,5);
    boss_bomb[4].frame[0]=create_sub_bitmap(bg,194,0,5,5);
    boss_bomb[5].frame[0]=create_sub_bitmap(bg,194,0,5,5);
    
    boss_bomb[6].frame[0] =create_sub_bitmap(bg,200,0,5,16);
    boss_bomb[7].frame[0] =create_sub_bitmap(bg,200,0,5,16);
    boss_bomb[8].frame[0] =create_sub_bitmap(bg,200,0,5,16);
    boss_bomb[9].frame[0] =create_sub_bitmap(bg,200,0,5,16);
    boss_bomb[10].frame[0]=create_sub_bitmap(bg,200,0,5,16);
    boss_bomb[11].frame[0]=create_sub_bitmap(bg,200,0,5,16);
   }
  if(fl==6) // Scena nostalgic
   {
    bg=load_bmp("data/video/stageold.bmp",pal);
    bgcol=2; txcol=10;
   }

  // Grafica comune
  set_palette(pal);
  st=17;
  h=256;
  for(int i=0;i<7;i++) player.frame[i]=create_sub_bitmap(bg,st*i,h-st+1,st-1,st-1);
  for(int i=0;i<7;i++) player2.frame[i]=create_sub_bitmap(bg,st*i,87,st-1,st-1);
  for(int k=0;k<5;k++)
   {
    h=256-st*(-k+6);
    for(int j=0;j<9;j++)
     {
      for(int i=0;i<9;i++) alien[j][k].frame[i]=create_sub_bitmap(bg,st*i,h-st+1,st-1,st-1);
     }
   }
  h=256-st*7;
  for(int k=0;k<10;k++) for(int i=0;i<1;i++) bomb[k].frame[i]=create_sub_bitmap(bg,st*i,h-st+1,st-1,st-1);

  for(int j=0;j<4;j++) for(int i=0;i<3;i++) bullet[j].frame[i]=create_sub_bitmap(bg,5*i+i,223,5,16);
  for(int j=0;j<4;j++) for(int i=0;i<7;i++) bullet[j].frame[i+3]=create_sub_bitmap(bg,287-33,26+32*i+i,32,32);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet[j].frame[i+10]=create_sub_bitmap(bg,640+60*i+i,0  ,60,60);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet[j].frame[i+12]=create_sub_bitmap(bg,640+60*i+i,61 ,60,60);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet[j].frame[i+14]=create_sub_bitmap(bg,640+60*i+i,122,60,60);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet[j].frame[i+16]=create_sub_bitmap(bg,640+60*i+i,183,60,60);

  for(int j=0;j<4;j++) for(int i=0;i<3;i++) bullet2[j].frame[i]=create_sub_bitmap(bg,5*i+i,223,5,16);
  for(int j=0;j<4;j++) for(int i=0;i<7;i++) bullet2[j].frame[i+3]=create_sub_bitmap(bg,287-33,26+32*i+i,32,32);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet2[j].frame[i+10]=create_sub_bitmap(bg,640+60*i+i,0  ,60,60);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet2[j].frame[i+12]=create_sub_bitmap(bg,640+60*i+i,61 ,60,60);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet2[j].frame[i+14]=create_sub_bitmap(bg,640+60*i+i,122,60,60);
  for(int j=0;j<4;j++) for(int i=0;i<2;i++) bullet2[j].frame[i+16]=create_sub_bitmap(bg,640+60*i+i,183,60,60);
  
  for(int i=0;i<10;i++) bonus.frame[i]=create_sub_bitmap(bg,18+16*i+i,223,16,16);
  for(int i=0;i<5;i++) bonus.frame[i+10]=create_sub_bitmap(bg,153,138+16*i+i,16,16);
  
  ship.frame[0]=create_sub_bitmap(bg,34,121,48,16); ship.frame[1]=create_sub_bitmap(bg,83,121,48,16);
  ship.frame[2]=create_sub_bitmap(bg,34,104,48,16); ship.frame[3]=create_sub_bitmap(bg,83,104,48,16);
  for(int i=0;i<7;i++) ship.frame[i+4]=create_sub_bitmap(bg,287,26+32*i+i,32,32);
  for(int i=0;i<5;i++) ship_bomb.frame[i]=create_sub_bitmap(bg,221,92+32*i+i,32,32);
  
  for(int k=0;k<7;k++) for(int i=0;i<7;i++) explosion[k].frame[i]=create_sub_bitmap(bg,287,26+32*i+i,32,32);
  
  board1.frame=create_sub_bitmap(bg,320,0  ,320,9);
  board2.frame=create_sub_bitmap(bg,320,223,320,10);
  
  // Suono comune
  //bgsound=load_midi("data/audio/bgsound.mid");
  //play_midi(bgsound,1);
  pl_fx[0]=load_sample("data/audio/fire1.wav");
  pl_fx[1]=load_sample("data/audio/boom2.wav");
  pl_fx[2]=load_sample("data/audio/bell1.wav");
  pl_fx[3]=load_sample("data/audio/error.wav");
  pl_fx[4]=load_sample("data/audio/cash.wav");
  al_fx[0]=load_sample("data/audio/boom1.wav");
  al_fx[1]=load_sample("data/audio/hit1.wav");
  al_fx[2]=load_sample("data/audio/fiii1.wav");
  al_fx[3]=load_sample("data/audio/boom3.wav");
 }

void GameInit()
 {
  gameover=false; gameover1=false; gameover2=false;
  level=1; lives=LIVES; lives2=LIVES;
  money=MONEY; score=0; money2=MONEY; score2=0;
  al_hits=1*SKILL;
  act_boss=1; bosshere=false;
  weapon=WEAPON; power=POWER;
  weapon2=WEAPON; power2=POWER;
  bonus.active=false;
  bonus.sec=0;
  bonus.y=206;
 }

void CheckExtra()
 {
  if(weapon==1) { bul_pw=1;       bul_speed=power+1; if(bul_speed>3) bul_speed=3; }
  if(weapon==2) { bul_pw=power+1; bul_speed=power+2; }
  if(weapon==3) { bul_pw=1;       bul_speed=power;   if(bul_speed>2) bul_speed=2; }
  if(weapon==1) mbul=power+1; else mbul=power;

  if(weapon2==1) { bul_pw2=1;        bul_speed2=power2+1; if(bul_speed2>3) bul_speed2=3; }
  if(weapon2==2) { bul_pw2=power2+1; bul_speed2=power2+2; }
  if(weapon2==3) { bul_pw2=1;        bul_speed2=power2;   if(bul_speed2>2) bul_speed2=2; }
  if(weapon2==1) mbul2=power2+1; else mbul2=power2;
 }

void Title()
 {
  int st,pos;
  char lc0,rc0,lc1,rc1,lc2,rc2;
  
  st=16; pos=0;
  SKILL=1; lc0=' '; rc0='>';
  LIVES=3; lc1=' '; rc1='>';
  MODE=1;  lc2=' '; rc2='>';
  MONEY=0; POWER=1; WEAPON=1;
  LoadData(0);
  ToScreen(bg);
  fade_in(pal,2);
  Credits();
  while(!(key[KEY_SPACE] && pos==4))
   {
    textprintf_ex(bg,font,0,0,8,0,VER);
    rectfill(bg,220,5,317,5+st*7+2,0);
    if(SKILL==1) textprintf_ex(bg,font,221+1 ,11+st*0,10,0,"%c   Easy   %c",lc0,rc0);
    if(SKILL==2) textprintf_ex(bg,font,221+1 ,11+st*0,10,0,"%c  Medium  %c",lc0,rc0);
    if(SKILL==3) textprintf_ex(bg,font,221+1 ,11+st*0,10,0,"%c   Hard   %c",lc0,rc0);
    textprintf_ex(bg,font,221+1 ,11+st*1,10,0,             "%c %d lives  %c",lc1,LIVES,rc1);
    if(MODE==1) textprintf_ex(bg,font,221+1 ,11+st*2,10,0, "%cNormal 1P %c",lc2,rc2);
    if(MODE==2) textprintf_ex(bg,font,221+1 ,11+st*2,10,0, "%c  Old 1P  %c",lc2,rc2);
    if(MODE==3) textprintf_ex(bg,font,221+1 ,11+st*2,10,0, "%cNormal 2P %c",lc2,rc2);
    if(MODE==4) textprintf_ex(bg,font,221+1 ,11+st*2,10,0, "%c  Old 2P  %c",lc2,rc2);
    textprintf_ex(bg,font,221+9 ,11+st*3,10,0,"PLAY INTRO");
    textprintf_ex(bg,font,221+9 ,11+st*4,10,0,"START GAME");
    textprintf_ex(bg,font,221+9 ,11+st*5,10,0,"SCOREBOARD");
    textprintf_ex(bg,font,221+13,11+st*6,10,0,"QUIT GAME");
    rect(bg,220,5,317,5+st*7+2,5);
    rect(bg,221,6+st*pos,316,6+st*pos+st,4);
    ToScreen(bg);
    clear_keybuf(); readkey();
    if(key[KEY_UP])   { pos--; play_sample(pl_fx[2],120,150,1000,0); }
    if(key[KEY_DOWN]) { pos++; play_sample(pl_fx[2],120,150,1000,0); }
    if(pos<0) pos=0; if(pos>6) pos=6;
    if(key[KEY_LEFT]  && pos==0) { SKILL--; if(SKILL<1) SKILL=1; if(SKILL==2) {lc0='<'; rc0='>';} else {lc0=' '; rc0='>'; }}
    if(key[KEY_RIGHT] && pos==0) { SKILL++; if(SKILL>3) SKILL=3; if(SKILL==2) {lc0='<'; rc0='>';} else {lc0='<'; rc0=' '; }}
    if(key[KEY_LEFT]  && pos==1) { LIVES=3; lc1=' '; rc1='>'; }
    if(key[KEY_RIGHT] && pos==1) { LIVES=5; lc1='<'; rc1=' '; }
    if(key[KEY_LEFT]  && pos==2) { MODE--; if(MODE<1) MODE=1; if(MODE==3 || MODE==2) {lc2='<'; rc2='>';} else {lc2=' '; rc2='>'; }}
    if(key[KEY_RIGHT] && pos==2) { MODE++; if(MODE>4) MODE=4; if(MODE==3 || MODE==2) {lc2='<'; rc2='>';} else {lc2='<'; rc2=' '; }}
    if(key[KEY_SPACE] && pos==3) { Intro(); }
    if(key[KEY_V] && key[KEY_U] && pos==4) { textprintf_ex(bg,font,0,8,10,0,":-O"); CHEAT=true; CHEAT2=false; }
    if(key[KEY_K]     && pos==4) { textprintf_ex(bg,font,0,8,10,0,":-)"); CHEAT2=true; CHEAT=false;  }
    if(key[KEY_X]     && pos==4) { textprintf_ex(bg,font,0,8,10,0,":-("); CHEAT=false; CHEAT2=false; }
    if(key[KEY_SPACE] && pos==5) { ScoreBoardShow(0); }
    if(key[KEY_SPACE] && pos==6) { Exit(); }
   }
  if(MODE>2) { NPLAYERS=2; if(MODE==3) MODE=1; if(MODE==4) MODE=2; } else {NPLAYERS=1;}
  if(CHEAT)  { MONEY=50000; WEAPON=3; POWER=3; LIVES=10; speed=2; speed2=2; }
  if(CHEAT2) { MONEY=12000; speed=1; }
  if(!CHEAT && !CHEAT2)
   {
  	if(SKILL==1) MONEY=1500;
    if(SKILL==2) MONEY=1000;
    if(SKILL==3) MONEY=500;
    WEAPON=1; POWER=1; speed=1; speed2=1;
   }
  if(MODE==2) { WEAPON=1; POWER=1; speed=2; speed2=2; }
  if(SKILL==1) { bo_m=2; }
  if(SKILL==2) { bo_m=1; }
  if(SKILL==3) { bo_m=1; }
  fade_out(4);  
 }

void Shop()
 {
  int st,pos;
  int err=0;
  
  if(lives<=0) return;
  st=16; pos=0;
  LoadData(-1);
  ToScreen(bg);
  fade_in(pal,1);
  while(!(key[KEY_SPACE] && pos==0))
   {
   	if(err==0) { textprintf_ex(bg,font,0,236,14,2,"                             "); err=-1; }
   	if(err==1) textprintf_ex(bg,font,0,236,14,2,"This item its at maximus!    ");
   	if(err==2) textprintf_ex(bg,font,0,236,14,2,"Insufficent money!           ");
   	if(err==3) textprintf_ex(bg,font,0,236,14,2,"You have already this weapon!");
   	if(err!=-1) { play_sample(pl_fx[3],120,150,1000,0); err=-1; }
   	textprintf_ex(bg,font,0,228,14,2,"Player 1 please choose your items...");
   	textprintf_ex(bg,font,273,120,14,2,"   ");
    textprintf_ex(bg,font,273,120,14,2,"%d",lives);
    textprintf_ex(bg,font,8,120,14,2,"       ");
    textprintf_ex(bg,font,8,120,14,2,"%d",money);
    draw_sprite(bg,shop[weapon],250,170);
    draw_sprite(bg,shop[0],25, 81);
    draw_sprite(bg,shop[0],70, 52);
    draw_sprite(bg,shop[0],70, 81);
    draw_sprite(bg,shop[0],70, 110);
    draw_sprite(bg,shop[0],70, 170);
    draw_sprite(bg,shop[0],115,170);
    draw_sprite(bg,shop[0],160,170);
    if(pos==0) rect(bg,25, 81 ,51, 106,18);
    if(pos==1) rect(bg,70, 52 ,96, 77, 18);
    if(pos==2) rect(bg,70, 81 ,96, 106,18);
    if(pos==3) rect(bg,70, 110,96, 135,18);
    if(pos==4) rect(bg,70, 170,96, 195,18);
    if(pos==5) rect(bg,115,170,141,195,18);
    if(pos==6) rect(bg,160,170,186,195,18);
    if(power==2) rectfill(bg,281,67,289,76,18);
    if(power==3) { rectfill(bg,281,67,289,76,18); rectfill(bg,293,67,301,76,18); }
    if(speed==2) rectfill(bg,281,82,289,91,18);
    if(speed==3) { rectfill(bg,281,82,289,91,18); rectfill(bg,293,82,301,91,18); }
    ToScreen(bg);
    clear_keybuf(); readkey();
    if(key[KEY_UP])    { if(pos<=4) pos--; if(pos==0) pos=1; }
    if(key[KEY_DOWN])  { if(pos>=1 && pos<=3) pos++; }
    if(key[KEY_LEFT])  { if(pos<=3) pos=0; else pos--; if(pos==3) pos=4; }
    if(key[KEY_RIGHT]) { if(pos>=4) pos++; if(pos==0) pos=2; }
    if(pos<0) pos=0; if(pos>6) pos=6;
    if(key[KEY_SPACE] && pos==1) { if(money>=5000) { if(power<3) { play_sample(pl_fx[4],120,150,1000,0); money-=5000; power++; } else err=1; } else err=2; }
    if(key[KEY_SPACE] && pos==2) { if(money>=2000) { if(speed<3) { play_sample(pl_fx[4],120,150,1000,0); money-=2000; speed++; } else err=1; } else err=2; }
    if(key[KEY_SPACE] && pos==3) { if(money>=5000) { play_sample(pl_fx[4],120,150,1000,0); money-=5000; lives++; } else err=2; }
    if(key[KEY_SPACE] && pos==4) { if(money>=3000 && weapon!=1) { play_sample(pl_fx[4],120,150,1000,0); money-=3000; weapon=1; } else { if(weapon==1) err=3; else err=2; }}
    if(key[KEY_SPACE] && pos==5) { if(money>=6000 && weapon!=2) { play_sample(pl_fx[4],120,150,1000,0); money-=6000; weapon=2; } else { if(weapon==2) err=3; else err=2; }}
    if(key[KEY_SPACE] && pos==6) { if(money>=8000 && weapon!=3) { play_sample(pl_fx[4],120,150,1000,0); money-=8000; weapon=3; } else { if(weapon==3) err=3; else err=2; }}
   }
  CheckExtra();
  fade_out(2);
 }

void Shop2()
 {
  int st,pos;
  int err=0;

  if(lives2<=0 || NPLAYERS!=2) return;  
  st=16; pos=0;
  LoadData(-1);
  ToScreen(bg);
  fade_in(pal,1);
  while(!(key[KEY_G] && pos==0))
   {
   	if(err==0) { textprintf_ex(bg,font,0,236,14,2,"                             "); err=-1; }
   	if(err==1) textprintf_ex(bg,font,0,236,14,2,"This item its at maximus!    ");
   	if(err==2) textprintf_ex(bg,font,0,236,14,2,"Insufficent money!           ");
   	if(err==3) textprintf_ex(bg,font,0,236,14,2,"You have already this weapon!");
   	if(err!=-1) { play_sample(pl_fx[3],120,150,1000,0); err=-1; }
   	textprintf_ex(bg,font,0,228,14,2,"Player 2 please choose your items...");
   	textprintf_ex(bg,font,273,120,14,2,"   ");
    textprintf_ex(bg,font,273,120,14,2,"%d",lives2);
    textprintf_ex(bg,font,8,120,14,2,"       ");
    textprintf_ex(bg,font,8,120,14,2,"%d",money2);
    draw_sprite(bg,shop[weapon2],250,170);
    draw_sprite(bg,shop[0],25, 81);
    draw_sprite(bg,shop[0],70, 52);
    draw_sprite(bg,shop[0],70, 81);
    draw_sprite(bg,shop[0],70, 110);
    draw_sprite(bg,shop[0],70, 170);
    draw_sprite(bg,shop[0],115,170);
    draw_sprite(bg,shop[0],160,170);
    if(pos==0) rect(bg,25, 81 ,51, 106,18);
    if(pos==1) rect(bg,70, 52 ,96, 77, 18);
    if(pos==2) rect(bg,70, 81 ,96, 106,18);
    if(pos==3) rect(bg,70, 110,96, 135,18);
    if(pos==4) rect(bg,70, 170,96, 195,18);
    if(pos==5) rect(bg,115,170,141,195,18);
    if(pos==6) rect(bg,160,170,186,195,18);
    if(power==2) rectfill(bg,281,67,289,76,18);
    if(power==3) { rectfill(bg,281,67,289,76,18); rectfill(bg,293,67,301,76,18); }
    if(speed==2) rectfill(bg,281,82,289,91,18);
    if(speed==3) { rectfill(bg,281,82,289,91,18); rectfill(bg,293,82,301,91,18); }
    ToScreen(bg);
    clear_keybuf(); readkey();
    if(key[KEY_W]) { if(pos<=4) pos--; if(pos==0) pos=1; }
    if(key[KEY_S]) { if(pos>=1 && pos<=3) pos++; }
    if(key[KEY_A]) { if(pos<=3) pos=0; else pos--; if(pos==3) pos=4; }
    if(key[KEY_D]) { if(pos>=4) pos++; if(pos==0) pos=2; }
    if(pos<0) pos=0; if(pos>6) pos=6;
    if(key[KEY_G] && pos==1) { if(money2>=5000) { if(power2<3) { play_sample(pl_fx[4],120,150,1000,0); money2-=5000; power2++; } else err=1; } else err=2; }
    if(key[KEY_G] && pos==2) { if(money2>=2000) { if(speed2<3) { play_sample(pl_fx[4],120,150,1000,0); money2-=2000; speed2++; } else err=1; } else err=2; }
    if(key[KEY_G] && pos==3) { if(money2>=5000) { play_sample(pl_fx[4],120,150,1000,0); money2-=5000; lives2++; } else err=2; }
    if(key[KEY_G] && pos==4) { if(money2>=3000 && weapon2!=1) { play_sample(pl_fx[4],120,150,1000,0); money2-=3000; weapon2=1; } else { if(weapon2==1) err=3; else err=2; }}
    if(key[KEY_G] && pos==5) { if(money2>=6000 && weapon2!=2) { play_sample(pl_fx[4],120,150,1000,0); money2-=6000; weapon2=2; } else { if(weapon2==2) err=3; else err=2; }}
    if(key[KEY_G] && pos==6) { if(money2>=8000 && weapon2!=3) { play_sample(pl_fx[4],120,150,1000,0); money2-=8000; weapon2=3; } else { if(weapon2==3) err=3; else err=2; }}
   }
  CheckExtra();
  fade_out(2);
 }

void LevelInit()
 {
  if(MODE==2)   { if(level==1) LoadData(6); return; }
  if(level==1)  LoadData(1);
  if(level==5)  { bosshere=true; act_boss=1; BossInit(act_boss); } // Mostro 1
  if(level==6)  { fade_out(5); Shop(); Shop2(); LoadData(2); al_hits=2*SKILL; ShipInit(al_hits); PlayerInit(); bonus.active=false; }
  if(level==10) { bosshere=true; act_boss=2; BossInit(act_boss); } // Mostro 2
  if(level==11) { fade_out(5); Shop(); Shop2(); LoadData(3); al_hits=3*SKILL; ShipInit(al_hits); PlayerInit(); bonus.active=false; }
  if(level==15) { bosshere=true; act_boss=3; BossInit(act_boss); } // Mostro 3 (in corso)
  if(level==16) { fade_out(5); Shop(); Shop2(); LoadData(4); al_hits=4*SKILL; ShipInit(al_hits); PlayerInit(); bonus.active=false; }
  if(level==20) { bosshere=true; act_boss=4; BossInit(act_boss); } // Mostro 4
  if(level==21) { fade_out(5); Shop(); Shop2(); LoadData(5); al_hits=5*SKILL; ShipInit(al_hits); PlayerInit(); bonus.active=false; }
  if(level==25) { bosshere=true; act_boss=5; BossInit(act_boss); } // Mostro 5 (da fare)
  if(level==26) { End(); }
 }
 
int InitPlay()
 {
  GameInit();
  BossInit(act_boss);
  CheckExtra();
  PlayerInit();
  AliensInit(al_hits);
  LevelInit();
  ShipInit(al_hits);
 }

void ScoreBoard(int fl)
 {
  if(fl==1) ScoreBoardInit();
  if(fl==2) // Enter, show and write in file
   {
    int pos=-1;
    for(int i=0;i<5;i++) if(score>scoretb[i].score) { pos=i; break; }
    if(pos>=0)
     {
      for(int i=4;i>pos;i--)
       {
        sprintf(scoretb[i].name,scoretb[i-1].name);
        scoretb[i].score=scoretb[i-1].score;
        scoretb[i].level=scoretb[i-1].level;
       }
      sprintf(scoretb[pos].name,""); scoretb[pos].score=score; scoretb[pos].level=level;
      hiscore=scoretb[0].score;
     }
    if(pos>=0)
     {
      ScoreBoardShow(1);
      if(pos>=0) { ScoreBoardInput(pos,1); ScoreBoardWrite(); ScoreBoardShow(0); }
      clear_keybuf(); readkey();
      fade_out(4);
     }
    if(NPLAYERS==2)
     {
      pos=-1;
      for(int i=0;i<5;i++) if(score2>scoretb[i].score) { pos=i; break; }
      if(pos>=0)
       {
        for(int i=4;i>pos;i--)
         {
          sprintf(scoretb[i].name,scoretb[i-1].name);
          scoretb[i].score=scoretb[i-1].score;
          scoretb[i].level=scoretb[i-1].level;
         }
        sprintf(scoretb[pos].name,""); scoretb[pos].score=score2; scoretb[pos].level=level;
        hiscore=scoretb[0].score;
       }
      if(pos>=0)
       {
        ScoreBoardShow(1);
        if(pos>=0) { ScoreBoardInput(pos,2); ScoreBoardWrite(); ScoreBoardShow(0); }
        clear_keybuf(); readkey();
        fade_out(4);
       }
     }
   }
 }

void GameOver()
 {
  wait(500);
  fade_out(2);
  clear_to_color(buffer,bgcol);
  set_palette(pal);
  textprintf_ex(buffer,font,160-36,128-4,txcol,bgcol,"GAME OVER");
  ToScreen(buffer);
  wait(2000);
  fade_out(4);
  ScoreBoard(2);
 }

void GameControl()
 {
  Board();
  if(NPLAYERS==1) { if(key[KEY_G]) Player2Enter(); }
  if(score>hiscore) hiscore=score; if(NPLAYERS==2) { if(score2>hiscore) hiscore=score2; }
  if(level<=10)
   {
    if(al_count>=0  && al_count<10) { al_dxm=5; }
    if(al_count>=10 && al_count<20) { al_dxm=4; }
    if(al_count>=20 && al_count<30) { al_dxm=3; }
    if(al_count>=30 && al_count<39) { al_dxm=2; }
    if(al_count==39)                { al_dxm=1; }
    if(al_count==40) { msss=clock(); synss=false; al_count=-1; } // Prossimo livello
   }
  else
   {
    if(al_count>=0  && al_count<5)  { al_dxm=5; }
    if(al_count>=5  && al_count<10) { al_dxm=4; }
    if(al_count>=10 && al_count<20) { al_dxm=3; }
    if(al_count>=20 && al_count<30) { al_dxm=2; }
    if(al_count>=30 && al_count<39) { al_dxm=1; }
    if(al_count==39)                { al_dxm=0; }
    if(al_count==40) { msss=clock(); synss=false; al_count=-1; } // Prossimo livello
   }
  if(al_count==-1) { if(synss) { level++; LevelInit(); AliensInit(al_hits); }}
  if(NPLAYERS==1)
   {
    if(!player.boom)
     {
      if(lives==0) gameover1=true;
      if(gameover1) gameover=true;
      if(gameover) GameOver();
     }
   }
  else
   {
    if(!player.boom)
     {
      if(lives==0) gameover1=true;
      if(gameover1 && gameover2) gameover=true;
     }
    if(!player2.boom)
     {
     	if(gameover1 && gameover2) gameover=true;
      if(lives2==0) gameover2=true;
     }
    if(gameover) GameOver();
   }
 }

void Animation()
 {
  if(level<=5) // Scena 1
   {
    draw_sprite(buffer,anim[0].frame[anim[0].actfr],148,166);
    if(syn) { anim[0].actfr++; anim[0].actfr=anim[0].actfr%anim[0].maxfr; }
   }
  if(level>=6 && level <=10) // Scena 2
   {
    draw_sprite(buffer,anim[0].frame[anim[0].actfr],119,109);
    if(syns) { anim[0].actfr++; anim[0].actfr=anim[0].actfr%anim[0].maxfr; }
    draw_sprite(buffer,anim[1].frame[anim[1].actfr],211,55);
    if(synf) { anim[1].actfr++; anim[1].actfr=anim[1].actfr%anim[1].maxfr; }
   }
 }

void Paint()
 {
  clear_to_color(buffer,bgcol);
  masked_blit(bg,buffer,320,0,0,0,SCR_W,SCR_H);
 }

void PlayerInit()
 {
  push=true;
  ibul=0;
  player.boom=false;
  player.x=50; player.y=206; player.actfr=0;
  for(int i=0;i<3;i++) { bullet[i].hits=bul_pw; bullet[i].v=bul_speed; bullet[i].actfr=0; bullet[i].fired=false; bullet[i].boom=false; }
  bul_aux=0;
  player.invis=22;
  
  push2=true;
  ibul2=0;
  player2.boom=false;
  player2.x=270; player2.y=206; player2.actfr=0;
  for(int i=0;i<3;i++) { bullet2[i].hits=bul_pw2; bullet2[i].v=bul_speed2; bullet2[i].actfr=0; bullet2[i].fired=false; bullet2[i].boom=false; }
  bul_aux2=0;
  player2.invis=22;
  
  AliensBombInit();
 }

void PlayerRestart()
 {
  player.boom=false;
  player.x=50; player.y=206; player.actfr=0;
  player.invis=22;
 }

void PlayerRestart2()
 {
  player2.boom=false;
  player2.x=270; player2.y=206; player2.actfr=0;
  player2.invis=22;
 }

void Player2Enter()
 {
  NPLAYERS=2;
  score2=0;
  lives2=LIVES;
  push2=true;
  ibul2=0;
  player2.boom=false;
  player2.x=270; player2.y=206; player2.actfr=0;
  for(int i=0;i<3;i++) { bullet2[i].hits=bul_pw2; bullet2[i].v=bul_speed2; bullet2[i].actfr=0; bullet2[i].fired=false; bullet2[i].boom=false; }
  bul_aux2=0;
  player2.invis=22;  
 }

void Bonus()
 {
  if(!bonus.active && Random(140)==0)
   {
    bonus.active=true; bonus.actfr=Random(4); bonus.x=Random(280)+20;
    if(bonus.actfr==0) { bonus.value=100; bonus.money=true; }
    if(bonus.actfr==1) { bonus.value=250; bonus.money=true; }
    if(bonus.actfr==2) { bonus.value=500; bonus.money=true; }
    if(bonus.actfr==3) { bonus.value=300; bonus.money=false; }
    if(bonus.actfr==4) { bonus.value=800; bonus.money=false; }
    bonus.y=206;
    mss2=clock(); syns2=false; bonus.sec=0;
   }
  if(bonus.active) { if(syns2) bonus.sec++; if(bonus.sec==8) bonus.active=false; }
  if(bonus.active)
   {
    draw_sprite(buffer,bonus.frame[bonus.actfr],bonus.x,bonus.y);
    // Collisione giocatore con bonus
    if(lives>=1)
     {
      if(hitTest(player.frame[1],bonus.frame[bonus.actfr],player.x,player.y,bonus.x,bonus.y) && bonus.actfr<=4)
       {
        play_sample(pl_fx[2],120,150,1000,0);
        bonus.actfr+=5;
        mss2=clock(); syns2=false;
        if(bonus.money) money+=bonus.value; else score+=bonus.value;
       }
     }
    if(NPLAYERS==2 && lives2>=1)
     {
     	if(hitTest(player2.frame[1],bonus.frame[bonus.actfr],player2.x,player2.y,bonus.x,bonus.y) && bonus.actfr<=4)
       {
        play_sample(pl_fx[2],120,150,1000,0);
        bonus.actfr+=10;
        mss2=clock(); syns2=false;
        if(bonus.money) money2+=bonus.value; else score2+=bonus.value;
       }
     }
    if(bonus.actfr>4)
     {
      if(synff) bonus.y--;
      if(syns2) bonus.active=false;
     }
   }
 }

void Bullet()
 {
  if(!player.boom) if(key[KEY_SPACE] && push && !bullet[ibul].fired) { play_sample(pl_fx[0],150,200,1000,0); bullet[ibul].x=player.x+6; bullet[ibul].y=player.y; bullet[ibul].v=bul_speed; bullet[ibul].fired=true; push=false; ibul++; ibul=ibul%mbul; }
  if(!key[KEY_SPACE]) { push=true; }
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired)
    {
     if(bullet[i].boom)
      {
       draw_sprite(buffer,bullet[i].frame[bullet[i].actfr],bullet[i].x,bullet[i].y);
       bul_aux++;
       if(power==1) { if(bul_aux%2==0) bullet[i].actfr++; if(bullet[i].actfr==8)  { bullet[i].boom=false; bullet[i].fired=false; bullet[i].hits=bul_pw; bullet[i].actfr=2; }}
       if(power==2) { if(bul_aux%3==0) bullet[i].actfr++; if(bullet[i].actfr==10) { bullet[i].boom=false; bullet[i].fired=false; bullet[i].hits=bul_pw; bullet[i].actfr=2; }}
       if(power==3) { if(bul_aux%3==0) bullet[i].actfr++; if(bullet[i].actfr==17) { bullet[i].boom=false; bullet[i].fired=false; bullet[i].hits=bul_pw; bullet[i].actfr=2; }}
      }
     else { draw_sprite(buffer,bullet[i].frame[weapon-1],bullet[i].x,bullet[i].y); bullet[i].y-=bullet[i].v; }
     if(bullet[i].y<-6) { bullet[i].hits=bul_pw; bullet[i].fired=false; bullet[i].boom=false; bullet[i].actfr=weapon-1; }
    }
 }

void Bullet2()
 {
  if(!player2.boom) if(key[KEY_G] && push2 && !bullet2[ibul2].fired) { play_sample(pl_fx[0],150,200,1000,0); bullet2[ibul2].x=player2.x+6; bullet2[ibul2].y=player2.y; bullet2[ibul2].v=bul_speed2; bullet2[ibul2].fired=true; push2=false; ibul2++; ibul2=ibul2%mbul2; }
  if(!key[KEY_G]) { push2=true; }
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired)
    {
     if(bullet2[i].boom)
      {
       draw_sprite(buffer,bullet2[i].frame[bullet2[i].actfr],bullet2[i].x,bullet2[i].y);
       bul_aux2++;
       if(power2==1) { if(bul_aux2%2==0) bullet2[i].actfr++; if(bullet2[i].actfr==8)  { bullet2[i].boom=false; bullet2[i].fired=false; bullet2[i].hits=bul_pw2; bullet2[i].actfr=2; }}
       if(power2==2) { if(bul_aux2%3==0) bullet2[i].actfr++; if(bullet2[i].actfr==10) { bullet2[i].boom=false; bullet2[i].fired=false; bullet2[i].hits=bul_pw2; bullet2[i].actfr=2; }}
       if(power2==3) { if(bul_aux2%3==0) bullet2[i].actfr++; if(bullet2[i].actfr==17) { bullet2[i].boom=false; bullet2[i].fired=false; bullet2[i].hits=bul_pw2; bullet2[i].actfr=2; }}
      }
     else { draw_sprite(buffer,bullet2[i].frame[weapon2-1],bullet2[i].x,bullet2[i].y); bullet2[i].y-=bullet2[i].v; }
     if(bullet2[i].y<-6) { bullet2[i].hits=bul_pw2; bullet2[i].fired=false; bullet2[i].boom=false; bullet2[i].actfr=weapon2-1; }
    }
 }

void Player()
 {
  if(!player.boom)
   {
    if(speed==1)
     {
      if(key[KEY_LEFT] ) { pl_n++; if(pl_n%2==0) { if(player.x>=1)   player.x-=1; }}
      if(key[KEY_RIGHT]) { pl_n++; if(pl_n%2==0) { if(player.x<=303) player.x+=1; }}
     }
    else
     {
      if(key[KEY_LEFT] ) { if(player.x>=1)   player.x-=speed-1; }
      if(key[KEY_RIGHT]) { if(player.x<=303) player.x+=speed-1; }
     }
   }
  draw_sprite(buffer,player.frame[player.actfr],player.x,player.y);
  if(player.boom) { if(synf) { player.actfr++; if(player.actfr==7) { /*wait(1250);*/ PlayerRestart(); }}}
  else
   {
  	if(player.invis>0) { if(synf) { player.invis--; player.actfr++; player.actfr=player.actfr%3; }}
  	else               { if(syn)  { player.actfr++; player.actfr=player.actfr%2; }}
   }
  Bullet();
 }

void Player2()
 {
  if(!player2.boom)
   {
    if(speed2==1)
     {
      if(key[KEY_A] ) { pl_n2++; if(pl_n2%2==0) { if(player2.x>=1)   player2.x-=1; }}
      if(key[KEY_D])  { pl_n2++; if(pl_n2%2==0) { if(player2.x<=303) player2.x+=1; }}
     }
    else
     {
      if(key[KEY_A] ) { if(player2.x>=1)   player2.x-=speed2-1; }
      if(key[KEY_D])  { if(player2.x<=303) player2.x+=speed2-1; }
     }
   }
  draw_sprite(buffer,player2.frame[player2.actfr],player2.x,player2.y);
  if(player2.boom) { if(synf) { player2.actfr++; if(player2.actfr==7) { /*wait(1250);*/ PlayerRestart2(); }}}
  else
   {
  	if(player2.invis>0) { if(synf) { player2.invis--; player2.actfr++; player2.actfr=player2.actfr%3; }}
  	else                { if(syn)  { player2.actfr++; player2.actfr=player2.actfr%2; }}
   }
  Bullet2();
 }

void RestoreBullet(int i)
 {
  bullet[i].hits--;
  if(bullet[i].hits==0)
   {
    if(weapon==3)
     {
      bullet[i].boom=true;
      //bullet[i].hits=bul_pw;
      if(power==1 || power==2)
       {
        bullet[i].actfr=3;
        bullet[i].x=bullet[i].x-14; bullet[i].y=bullet[i].y-10;
       }
      if(power==3)
       {
        bullet[i].actfr=10;
        bullet[i].x=bullet[i].x-28; bullet[i].y=bullet[i].y-16;
       }      
     }
    else
     {
      bullet[i].fired=false;
      bullet[i].hits=bul_pw;
     }
    for(int i=0;i<mbul;i++) if(!bullet[i].fired) ibul=i;
   }
 }

void RestoreBullet2(int i)
 {
  bullet2[i].hits--;
  if(bullet2[i].hits==0)
   {
    if(weapon2==3)
     {
      bullet2[i].boom=true;
      //bullet2[i].hits=bul_pw2;
      if(power2==1 || power2==2)
       {
        bullet2[i].actfr=3;
        bullet2[i].x=bullet2[i].x-14; bullet2[i].y=bullet2[i].y-10;
       }
      if(power2==3)
       {
        bullet2[i].actfr=10;
        bullet2[i].x=bullet2[i].x-28; bullet2[i].y=bullet2[i].y-16;
       }      
     }
    else
     {
      bullet2[i].fired=false;
      bullet2[i].hits=bul_pw2;
     }
    for(int i=0;i<mbul2;i++) if(!bullet2[i].fired) ibul2=i;
   }
 }

void Collision()
 {
  // Alieni con proiettile
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    for(int j=0;j<8;j++) 
     for(int k=0;k<5;k++) 
      if(!alien[j][k].dead && bullet[i].fired)
       if(weapon==3)
        {
         if(hitTestFast(bullet[i].frame[bullet[i].actfr],alien[j][k].frame[al_fr],bullet[i].x,bullet[i].y,alien[j][k].x,alien[j][k].y))
          {
           alien[j][k].hits--; score++;
           if(alien[j][k].hits<0) alien[j][k].hits=0;
           if(alien[j][k].hits>0) play_sample(al_fx[1],50,100,1000,0);
           alien[j][k].actfr=2;
           alien[j][k].hitted=true;
           if(alien[j][k].hits==0)
            {
             al_count++;
             score+=10+(5-k)*10;
             play_sample(al_fx[0],50,200,1000,0);
             alien[j][k].dead=true;
             alien[j][k].boom=true;
             alien[j][k].actfr=3;
            }
           RestoreBullet(i);
          }
        }
       else
        {
         if(hitTest(bullet[i].frame[bullet[i].actfr],alien[j][k].frame[al_fr],bullet[i].x,bullet[i].y,alien[j][k].x,alien[j][k].y))
          {
           alien[j][k].hits--; score++;
           if(alien[j][k].hits<0) alien[j][k].hits=0;
           if(alien[j][k].hits>0) play_sample(al_fx[1],50,100,1000,0);
           alien[j][k].actfr=2;
           alien[j][k].hitted=true;
           if(alien[j][k].hits==0)
            {
             al_count++;
             score+=10+(5-k)*10;
             play_sample(al_fx[0],50,200,1000,0);
             alien[j][k].dead=true;
             alien[j][k].boom=true;
             alien[j][k].actfr=3;
            }
           RestoreBullet(i);
          }
        }
   // Giocatore con bombe
   if(player.invis==0 && !player.boom)
    {
     for(int i=0;i<10;i++) 
      if(bomb[i].fired) 
       if(hitTest(player.frame[1],bomb[i].frame[0],player.x,player.y,bomb[i].x,bomb[i].y))
          {
           play_sample(pl_fx[1],120,150,1000,0);
           bomb[i].fired=false;
           lives--;
           player.actfr=3; player.boom=true;
          }
    }
 }

void Collision2()
 {
  // Alieni con proiettile
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    for(int j=0;j<8;j++) 
     for(int k=0;k<5;k++) 
      if(!alien[j][k].dead && bullet2[i].fired)
       if(weapon2==3)
        {
         if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],alien[j][k].frame[al_fr],bullet2[i].x,bullet2[i].y,alien[j][k].x,alien[j][k].y))
          {
           alien[j][k].hits--; score2++;
           if(alien[j][k].hits<0) alien[j][k].hits=0;
           if(alien[j][k].hits>0) play_sample(al_fx[1],50,100,1000,0);
           alien[j][k].actfr=2;
           alien[j][k].hitted=true;
           if(alien[j][k].hits==0)
            {
             al_count++;
             score2+=10+(5-k)*10;
             play_sample(al_fx[0],50,200,1000,0);
             alien[j][k].dead=true;
             alien[j][k].boom=true;
             alien[j][k].actfr=3;
            }
           RestoreBullet2(i);
          }
        }
       else
        {
         if(hitTest(bullet2[i].frame[bullet2[i].actfr],alien[j][k].frame[al_fr],bullet2[i].x,bullet2[i].y,alien[j][k].x,alien[j][k].y))
          {
           alien[j][k].hits--; score2++;
           if(alien[j][k].hits<0) alien[j][k].hits=0;
           if(alien[j][k].hits>0) play_sample(al_fx[1],50,100,1000,0);
           alien[j][k].actfr=2;
           alien[j][k].hitted=true;
           if(alien[j][k].hits==0)
            {
             al_count++;
             score2+=10+(5-k)*10;
             play_sample(al_fx[0],50,200,1000,0);
             alien[j][k].dead=true;
             alien[j][k].boom=true;
             alien[j][k].actfr=3;
            }
           RestoreBullet2(i);
          }
        }
   // Giocatore con bombe
   if(player2.invis==0 && !player2.boom)
    {
     for(int i=0;i<10;i++) 
      if(bomb[i].fired) 
       if(hitTest(player2.frame[1],bomb[i].frame[0],player2.x,player2.y,bomb[i].x,bomb[i].y))
          {
           play_sample(pl_fx[1],120,150,1000,0);
           bomb[i].fired=false;
           lives2--;
           player2.actfr=3; player2.boom=true;
          }
    }
 }

void ShipCollision()
 {
  // Collisioni ship con proiettile
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!ship.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],ship.frame[ship.actfr],bullet[i].x,bullet[i].y,ship.x,ship.y))
        {
         ship.hits--; score+=2;
         if(ship.hits<0) ship.hits=0;
         if(ship.hits>0) play_sample(al_fx[1],50,100,1000,0);
         ship.hitted=true;
         if(ship.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           ship.dead=true;
           ship.boom=true;
           ship.actfr=4;
           ship.x+=8; ship.y-=6;
           score+=250;
          }
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],ship.frame[ship.actfr],bullet[i].x,bullet[i].y,ship.x,ship.y))
        {
         ship.hits--; score+=2;
         if(ship.hits<0) ship.hits=0;
         if(ship.hits>0) play_sample(al_fx[1],50,100,1000,0);
         ship.hitted=true;
         if(ship.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           ship.dead=true;
           ship.boom=true;
           ship.actfr=4;
           ship.x+=8; ship.y-=6;
           score+=250;
          }
         RestoreBullet(i);
        }
      }      
  if(NPLAYERS==2)
   {
    for(int i=0;i<mbul2;i++)
     if(bullet2[i].fired) 
      if(!ship.dead && bullet2[i].fired)
       if(weapon2==3)
        {
         if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],ship.frame[ship.actfr],bullet2[i].x,bullet2[i].y,ship.x,ship.y))
          {
           ship.hits--; score2+=2;
           if(ship.hits<0) ship.hits=0;
           if(ship.hits>0) play_sample(al_fx[1],50,100,1000,0);
           ship.hitted=true;
           if(ship.hits==0)
            {
             play_sample(al_fx[0],50,200,1000,0);
             ship.dead=true;
             ship.boom=true;
             ship.actfr=4;
             ship.x+=8; ship.y-=6;
             score2+=250;
            }
           RestoreBullet2(i);
          }
        }
       else
        {
         if(hitTest(bullet2[i].frame[bullet2[i].actfr],ship.frame[ship.actfr],bullet2[i].x,bullet2[i].y,ship.x,ship.y))
          {
           ship.hits--; score2+=2;
           if(ship.hits<0) ship.hits=0;
           if(ship.hits>0) play_sample(al_fx[1],50,100,1000,0);
           ship.hitted=true;
           if(ship.hits==0)
            {
             play_sample(al_fx[0],50,200,1000,0);
             ship.dead=true;
             ship.boom=true;
             ship.actfr=4;
             ship.x+=8; ship.y-=6;
             score2+=250;
            }
           RestoreBullet2(i);
          }
        }         	
   }
 }

void AliensInit(int hits)
 {
  int pos;

  if(MODE==1) pos=((level-1)%5)*20; else { pos=((level-1)%4)*20; if(level>4) pos=3*20; }
  al_x=30; al_y=42+pos;
  al_v=al_dx=1; al_dx2=0; al_dxm=5; al_dy=0; al_dy2=0; al_dym=1,al_dytot=0;
  al_down=20; al_fr=0;
  al_count=0;
  for(int j=0;j<8;j++)
   for(int k=0;k<5;k++)
    {
     alien[j][k].actfr=0;
     alien[j][k].dead=false;
     alien[j][k].boom=false;
     alien[j][k].hitted=false;
     alien[j][k].x=al_x+20*j; alien[j][k].y=al_y+20*k;
     alien[j][k].hits=hits;
    }
  bo_d=0; if(SKILL<3) bo_v=1; else bo_v=2;
  AliensBombInit();
 }

void AliensBombInit()
 {
  for(int i=0;i<10;i++)
   {
    bomb[i].fired=false;
    bomb[i].actfr=0;
    bomb[i].x=0; bomb[i].y=0;
   }
 }

void AliensDraw()
 {
  for(int j=0;j<8;j++)
   for(int k=0;k<5;k++)
    {
     if(!alien[j][k].dead) { draw_sprite(buffer,alien[j][k].frame[al_fr],alien[j][k].x,alien[j][k].y); }
     if(alien[j][k].hitted)
      {
       draw_sprite(buffer,alien[j][k].frame[alien[j][k].actfr],alien[j][k].x,alien[j][k].y);
       if(synf) alien[j][k].hitted=false;
      }
     if(alien[j][k].boom)
      {
       draw_sprite(buffer,alien[j][k].frame[alien[j][k].actfr],alien[j][k].x,alien[j][k].y);
       if(synf) { alien[j][k].actfr++; if(alien[j][k].actfr==9) alien[j][k].boom=false; }
      }
    }
 }
 
void AlienShadow()
 {
  // Ombre
  if((level>0 && level<5) || (level>5 && level<10) || (level>20 && level<25))
   for(int j=0;j<8;j++)
    for(int k=0;k<5;k++)
     if(!alien[j][k].dead) { line(buffer,alien[j][k].x+2,216,alien[j][k].x+12,216,swcol); break; }
 }

void AliensDown()
 {
  al_dy2++;
  if(al_dy2%al_dym==0)
   {
    for(int j=0;j<8;j++) for(int k=0;k<5;k++) if(!alien[j][k].dead) { alien[j][k].y+=al_dy; }
    al_dytot++;
    if(al_dytot==al_down) al_dy=0;
   }
 }

void AliensMove()
 {
  al_dx2++;
  if(level<=10)
   {
    if(al_dx2%al_dxm==0)
     {
      for(int j=0;j<8;j++) for(int k=0;k<5;k++) if(!alien[j][k].dead) { alien[j][k].x+=al_dx; }
      for(int j=0;j<8;j++) for(int k=0;k<5;k++) if(!alien[j][k].dead)
       {
        if(alien[j][k].x<1)   { al_dx=al_v;  al_dy=1; al_dy2=0; al_dytot=0; }
        if(alien[j][k].x>303) { al_dx=-al_v; al_dy=1; al_dy2=0; al_dytot=0; }
       }
      for(int j=0;j<8;j++) for(int k=0;k<5;k++)
       if(!alien[j][k].dead) if(alien[j][k].y>200) { gameover=true; al_dy=1; al_dy2=0; al_dytot=15; }
     }
   }  
  else
   {
    if(al_dxm>0)
     {
      if(al_dx2%al_dxm==0)
       {
        for(int j=0;j<8;j++) for(int k=0;k<5;k++) if(!alien[j][k].dead) { alien[j][k].x+=al_dx; }
        for(int j=0;j<8;j++) for(int k=0;k<5;k++) if(!alien[j][k].dead)
         {
          if(alien[j][k].x<1)   { al_dx=al_v;  al_dy=1; al_dy2=0; al_dytot=0; }
          if(alien[j][k].x>303) { al_dx=-al_v; al_dy=1; al_dy2=0; al_dytot=0; }
         }
        for(int j=0;j<8;j++) for(int k=0;k<5;k++)
         if(!alien[j][k].dead) if(alien[j][k].y>200) { gameover=true; al_dy=1; al_dy2=0; al_dytot=15; }
       }
     }
    else
     {
      for(int j=0;j<8;j++) for(int k=0;k<5;k++) if(!alien[j][k].dead) { alien[j][k].x+=al_dx*2; }
      for(int j=0;j<8;j++) for(int k=0;k<5;k++) if(!alien[j][k].dead)
       {
        if(alien[j][k].x<1)   { al_dx=al_v;  al_dy=1; al_dy2=0; al_dytot=0; }
        if(alien[j][k].x>303) { al_dx=-al_v; al_dy=1; al_dy2=0; al_dytot=0; }
       }
      for(int j=0;j<8;j++) for(int k=0;k<5;k++)
       if(!alien[j][k].dead) if(alien[j][k].y>200) { gameover=true; al_dy=1; al_dy2=0; al_dytot=15; }
     }
   }
 }

void Ship()
 {
  ship.aux++;
  if(ship.stato==1)
   {
    if(!ship.boom) if(ship.aux%2==0) ship.x++;
    if(ship.x>320) ship.stato=0;
    if(ship.x>player.x && !ship_bomb.fired && !ship.boom)
     { ship_bomb.fired=true; ship_bomb.boom=false; ship_bomb.x=ship.x; ship_bomb.y=5; }
    ShipDraw();
    ShipCollision();
   }
  if(ship.stato==2)
   {
    if(!ship.boom) if(ship.aux%2==0) ship.x--;
    if(ship.x<-48) ship.stato=0;
    if(ship.x<player.x && !ship_bomb.fired && !ship.boom)
     { ship_bomb.fired=true; ship_bomb.boom=false; ship_bomb.x=ship.x; ship_bomb.y=5; }
    ShipDraw();
    ShipCollision();
   }
  if(ship.stato==0)
   {
    if(Random(300)==0)
     {
      if(Random(1)) { ship.stato=1; ship.x=-48; ship.actfr=0; }
      else { ship.stato=2; ship.x=320; ship.actfr=1; }
      ship.boom=false;
      ship.dead=false;
      ship.hitted=false;
      ship.hits=al_hits+1;
      ship.y=20;
     }
   }
  if(ship_bomb.fired) ShipBomb();  
 }

void ShipDraw()
 {
  if(!ship.hitted && !ship.boom) draw_sprite(buffer,ship.frame[ship.actfr],ship.x,ship.y);
  if(ship.hitted)
   {
    draw_sprite(buffer,ship.frame[ship.actfr+2],ship.x,ship.y);
    if(synf) ship.hitted=false;
   }
  if(ship.boom)
   {
    draw_sprite(buffer,ship.frame[ship.actfr],ship.x,ship.y);
    if(synf) { ship.actfr++; if(ship.actfr==11) { ship.boom=false; ship.stato=0; }}
   }
  if(ship_bomb.fired) draw_sprite(buffer,ship_bomb.frame[ship_bomb.actfr],ship_bomb.x,ship_bomb.y);
 }

void ShipBomb()
 {
  if(!ship_bomb.boom)
   {
    ship_bomb.y++;
    if(ship_bomb.y==20) play_sample(al_fx[2],80,100,1000,0);
    draw_sprite(buffer,ship_bomb.frame[ship_bomb.actfr],ship_bomb.x,ship_bomb.y);
   }
  if(ship_bomb.boom)
   {
    draw_sprite(buffer,ship_bomb.frame[ship_bomb.actfr],ship_bomb.x,ship_bomb.y);
    if(synf) { ship_bomb.actfr++; if(ship_bomb.actfr==5) { ship_bomb.boom=false; ship_bomb.fired=false; ship_bomb.actfr=0; }}
   }
  if(ship_bomb.y==189) { play_sample(al_fx[3],80,100,1000,0); }
  if(ship_bomb.y==190) { ship_bomb.boom=true; }
  
  // Collisioni giocatore con shipbomb
  if(player.invis==0 && !player.boom)
   {
    if(hitTest(player.frame[1],ship_bomb.frame[ship_bomb.actfr],player.x,player.y,ship_bomb.x,ship_bomb.y))
     {
      play_sample(pl_fx[1],120,150,1000,0);
      lives--;
      player.actfr=3; player.boom=true;
     }
   }
  if(player2.invis==0 && !player2.boom && NPLAYERS==2)
   {
    if(hitTest(player2.frame[1],ship_bomb.frame[ship_bomb.actfr],player2.x,player2.y,ship_bomb.x,ship_bomb.y))
     {
      play_sample(pl_fx[1],120,150,1000,0);
      lives2--;
      player2.actfr=3; player2.boom=true;
     }
   }   
 }

void ShipInit(int hits)
 {
  ship.stato=0;
  ship.aux=0;
  ship.x=-48; ship.y=20;
  ship.boom=false;
  ship.dead=false;
  ship.hitted=false;
  ship.hits=hits+1;
  ship.actfr=0;
  ship_bomb.fired=false;
  ship_bomb.boom=false;
  ship_bomb.actfr=0;
  ship_bomb.x=0; ship_bomb.y=0;
 }

void AliensBomb()
 {
  int rj,rk;

  for(int i=0;i<10;i++)
   if(!bomb[i].fired)
    {
     rj=Random(7);
     rk=Random(4);
     if(!alien[rj][rk].dead && Random(510-level*20)==0)
      {
       bomb[i].x=alien[rj][rk].x;
       bomb[i].y=alien[rj][rk].y;
       bomb[i].fired=true;
      }
    }
  bo_d++;
  for(int i=0;i<10;i++)
   if(bomb[i].fired)
    {
     if(SKILL<3) { if(bo_d%bo_m==0) bomb[i].y+=bo_v; } else bomb[i].y+=bo_v;
     draw_sprite(buffer,bomb[i].frame[0],bomb[i].x,bomb[i].y);
     if(bomb[i].y>209) bomb[i].fired=false;
    }
 }

void Aliens()
 {
  AliensDraw();
  if(al_dy>0) AliensDown();
  if(!gameover)
   {
    AliensMove();
    AliensBomb();
    if(syn) { al_fr++; al_fr=al_fr%2; }
   }
 }

void Boss()
 {
  if(act_boss==1 && !fl_des) fl_des=Boss1();
  if(act_boss==2 && !fl_des) fl_des=Boss2();
  if(act_boss==3 && !fl_des) fl_des=Boss3();
  if(act_boss==4 && !fl_des) fl_des=Boss4();
  if(act_boss==5 && !fl_des) fl_des=Boss5();
  if(fl_des)
   {
    fl_exp=BossExplode();
    if(fl_exp)
     {
      bosshere=false;
      level++;
      LevelInit();
      AliensInit(al_hits);
      PlayerInit();
     }
   }
 }

bool BossExplode()
 {
  int fl;
  
  if(exp_n>=60) { fl=0; for(int i=0;i<7;i++) { if(explosion[i].boom) fl=1; } if(fl==0) exp_n++; }
  for(int i=0;i<7;i++)
   {
    if(Random(5)==0 && exp_n<60)
     {
      if(!explosion[i].boom)
       {
        exp_n++;
        explosion[i].boom=true; explosion[i].actfr=0;
        explosion[i].x=boss.x+Random(60)-20;  explosion[i].y=boss.y+Random(80)-20;
        play_sample(al_fx[0],50,200,1000,0);        
       }
     }
    if(explosion[i].boom)
     {
      if(exp_n<=50) rotate_scaled_sprite(buffer,boss.frame[0],boss.x,boss.y,0,65536-exp_n*400);
      draw_sprite(buffer,explosion[i].frame[explosion[i].actfr],explosion[i].x,explosion[i].y);
      if(i%2==0) { if(syn)  { explosion[i].actfr++; if(explosion[i].actfr==7) { explosion[i].boom=false; }}}
      else       { if(synf) { explosion[i].actfr++; if(explosion[i].actfr==7) { explosion[i].boom=false; }}}
     }
   }
  if(exp_n>=200) return true;
  return false;
 }

void BossInit(int b)
 {
  if(b==1)
   {
    exp_n=0;
    fl_des=false; fl_exp=false;
    boss.x=100; boss.y=5;
    boss.dx=1; boss.dy=1;
    boss.aux=536;
    boss.state=0;
    boss.actfr=0;
    boss.sp=3;
    boss.hits=26*SKILL;
    boss.dead=false;
    boss.boom=false;
    boss.hitted=false;
    for(int i=0;i<5;i++) { boss_bomb[i].actfr=0; boss_bomb[i].fired=false; }
   }
  if(b==2)
   {
    exp_n=0;
    fl_des=false; fl_exp=false;
    boss.x=140; boss.y=60;
    boss.dx=2; boss.dy=1;
    boss.aux=536;
    boss.state=0;
    boss.actfr=0;
    boss.sp=3;
    boss.hits=50*SKILL;
    boss.dead=false;
    boss.boom=false;
    boss.hitted=false;
    boss.ang=0;
    boss.angsp=0.02;
    boss1.x=140; boss1.y=60;
    boss1.dx=2;  boss1.dy=1;
    boss1.aux=536;
    boss1.state=0;
    boss1.actfr=0;
    boss1.sp=3;
    boss1.hits=10*SKILL;
    boss1.dead=false;
    boss1.boom=false;
    boss1.hitted=false;
    boss1.ang=0;
    boss1.angsp=0.1;
    for(int i=0;i<6;i++) { boss_bomb[i].actfr=0; boss_bomb[i].fired=false; boss_bomb[i].sp=0; }
   }
  if(b==3)
   {
    exp_n=0;
    fl_des=false; fl_exp=false;
    boss.x=140; boss.y=60;
    boss.dx=2; boss.dy=1;
    boss.aux=536;
    boss.state=0;
    boss.actfr=0;
    boss.sp=3;
    boss.hits=70*SKILL;
    boss.dead=false;
    boss.boom=false;
    boss.hitted=false;
    boss.ang=0;
    boss.angsp=0.02;

    boss1.state=0; boss1.actfr=0; boss1.hits=1;
    boss1.dead=false; boss1.boom=false; boss1.hitted=false;
    boss1.ang=0; boss1.angsp=0.05; boss1.attack=0;

    boss2.state=0; boss2.actfr=0; boss2.hits=1;
    boss2.dead=false; boss2.boom=false; boss2.hitted=false;
    boss2.ang=0; boss2.angsp=0.05; boss2.attack=0;

    boss3.state=0; boss3.actfr=0; boss3.hits=1;
    boss3.dead=false; boss3.boom=false; boss3.hitted=false;
    boss3.ang=0; boss3.angsp=0.05; boss3.attack=0;

    boss4.state=0; boss4.actfr=0; boss4.hits=1;
    boss4.dead=false; boss4.boom=false; boss4.hitted=false;
    boss4.ang=0; boss4.angsp=0.05; boss4.attack=0;

    for(int i=0;i<4;i++) { boss_bomb[i].actfr=0; boss_bomb[i].fired=false; boss_bomb[i].sp=0; }
   }
  if(b==4)
   {
    exp_n=0;
    fl_des=false; fl_exp=false;
    boss.x=100; boss.y=5;
    boss.dx=1; boss.dy=1;
    boss.aux=536;
    boss.state=0;
    boss.actfr=0;
    boss.sp=2;
    boss.hits=80*SKILL;
    boss.dead=false;
    boss.boom=false;
    boss.hitted=false;
    for(int i=0;i<5;i++) { boss_bomb[i].actfr=0; boss_bomb[i].fired=false; }
   }   
  if(b==5)
   {
    exp_n=0;
    fl_des=false; fl_exp=false;
    boss.x=100; boss.y=5;
    boss.dx=1; boss.dy=1;
    boss.aux=536;
    boss.state=0;
    boss.actfr=0;
    boss.sp=2;
    boss.hits=100*SKILL;
    boss.dead=false;
    boss.boom=false;
    boss.hitted=false;
    boss.ang=0;
    boss.angsp=0.02;
    for(int i=0;i<12;i++) { boss_bomb[i].actfr=0; boss_bomb[i].fired=false; }
   }   
 }

bool Boss1()
 {
  boss.aux++; 	
  // Boss start
  if(boss.state==0)
   {
    rotate_scaled_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y,0,boss.aux); 
    if(boss.aux%boss.sp==0) boss.y+=boss.dy;
    boss.aux+=1000;
    if(boss.aux>=65536) { boss.state=1; boss.aux=0; }
    return false;
   }

  // Laser
  if(boss_bomb[0].fired)
   {
    draw_sprite(buffer,boss_bomb[0].frame[boss_bomb[0].actfr],boss_bomb[0].x,boss_bomb[0].y);
    draw_sprite(buffer,boss_bomb[1].frame[boss_bomb[1].actfr],boss_bomb[1].x,boss_bomb[1].y);
    boss_bomb[0].y+=3; boss_bomb[1].y+=3;
    if(boss_bomb[0].y>196) { boss_bomb[0].fired=false; boss_bomb[1].fired=false; }
   }
  if(boss.y<=10 && !boss_bomb[0].fired)
   {
    boss_bomb[0].x=boss.x+3;  boss_bomb[0].y=boss.y+40; boss_bomb[0].fired=true;
    boss_bomb[1].x=boss.x+43; boss_bomb[1].y=boss.y+40; boss_bomb[1].fired=true;
   }

  // Fiamma
  if(boss_bomb[2].fired)
   {
    draw_sprite(buffer,boss_bomb[2].frame[boss_bomb[2].actfr],boss_bomb[2].x,boss_bomb[2].y);
    boss_bomb[2].y++;
    if(boss_bomb[2].y>206) boss_bomb[2].fired=false;
   }
  if(boss.x%60==0 && !boss_bomb[2].fired)
   { boss_bomb[2].x=boss.x+24; boss_bomb[2].y=boss.y+54; boss_bomb[2].fired=true; }

  // Missili
  if(boss_bomb[3].fired)
   {
    draw_sprite(buffer,boss_bomb[3].frame[boss_bomb[3].actfr],boss_bomb[3].x,boss_bomb[3].y);
    draw_sprite(buffer,boss_bomb[4].frame[boss_bomb[4].actfr],boss_bomb[4].x,boss_bomb[4].y);
    boss_bomb[3].y+=2; boss_bomb[4].y+=2;
    boss_bomb[3].x--;  boss_bomb[4].x++;
    if(boss_bomb[3].y>207) { boss_bomb[3].fired=false; boss_bomb[4].fired=false; }
   }
  if(boss.x%32==0 && !boss_bomb[3].fired)
   {
    boss_bomb[3].x=boss.x+13;  boss_bomb[3].y=boss.y+45; boss_bomb[3].fired=true;
    boss_bomb[4].x=boss.x+33; boss_bomb[4].y=boss.y+45; boss_bomb[4].fired=true;
   }

  // Boss
  if(boss.aux%boss.sp==0)
   {
    boss.y+=boss.dy; boss.x+=boss.dx; 
    if(boss.y>=100) boss.dy*=-1; if(boss.y<=10) boss.dy*=-1;
    if(boss.x>=261) boss.dx*=-1; if(boss.x<=0)  boss.dx*=-1;
   }
  if(syn) { boss.actfr++; boss.actfr=boss.actfr%3; }
  if(boss.hitted) { boss.actfr=3; if(synff) boss.hitted=false; }
  draw_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y);

  // Collisioni Giocatore con boss_bomb
  if(player.invis==0 && !player.boom)
   {
    for(int i=0;i<5;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player.x,player.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives--;
          player.actfr=3; player.boom=true;
         }
   }
  // Collisioni boss con proiettile
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=12) boss.sp=2;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=1500;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=12) boss.sp=2;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=1500;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }

  // Collisioni Giocatore 2 con boss_bomb
  if(player2.invis==0 && !player2.boom)
   {
    for(int i=0;i<5;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player2.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player2.x,player2.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives2--;
          player2.actfr=3; player2.boom=true;
         }
   }
  // Collisioni boss con proiettile (giocatore 2)
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=12) boss.sp=2;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=1500;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=12) boss.sp=2;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=1500;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
  return false;
 }

bool Boss2()
 {
  boss.aux++; 	
  // Boss start
  if(boss.state==0)
   {
    rotate_scaled_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y,0,boss.aux); 
    if(boss.aux%boss.sp==0) boss.y+=boss.dy;
    boss.aux+=1000;
    if(boss.aux>=65536) { boss.state=1; boss.aux=0; }
    return false;
   }

  // Missili
  for(int i=0;i<6;i++)
   {
    if(boss_bomb[i].fired)
     {
      draw_sprite(buffer,boss_bomb[i].frame[boss_bomb[i].actfr],boss_bomb[i].x,boss_bomb[i].y);
      boss_bomb[i].y+=boss_bomb[i].sp;
      if(boss_bomb[i].y>206) boss_bomb[i].fired=false;
     }   	
    if(!boss_bomb[i].fired && Random(20)==0)
     {
      boss_bomb[i].x=boss.x+15; boss_bomb[i].y=boss.y+15;
      boss_bomb[i].fired=true;  boss_bomb[i].sp=Random(2)+1;
     }
   }
  // Boss
  boss.x=(int)(100*sin(boss.ang)); boss.y=(int)(40*cos(boss.ang));
  boss.x+=140; boss.y+=45;
  boss.ang+=boss.angsp; if(boss.ang>=360) boss.ang=0;    
  if(syn) { boss.actfr++; boss.actfr=boss.actfr%3; }
  if(boss.hitted) { boss.actfr=3; if(synff) boss.hitted=false; }
  draw_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y);
  // Boss extra
  if(!boss1.boom && boss1.state==0)
   {
    boss1.x=boss.x+2; boss1.y=boss.y+24;
    boss1.x+=(int)(28*sin(boss1.ang)); boss1.y+=(int)(30*cos(boss1.ang));
    boss1.ang+=boss1.angsp; if(boss1.ang>=360) boss1.ang=0;    
    draw_sprite(buffer,boss1.frame[boss1.actfr],boss1.x,boss1.y);
    if(boss1.hitted) { boss1.actfr=1; if(synff) { boss1.hitted=false; boss1.actfr=0; }}
   }
  if(boss1.boom)
   {
    boss1.x++; boss1.y+=2;
    if(syn) { boss1.actfr++; if(boss1.actfr==4) boss1.actfr=2; }
   	draw_sprite(buffer,boss1.frame[boss1.actfr],boss1.x,boss1.y);
   	if(boss1.y>203) { boss1.state=1; boss1.boom=false; boss1.actfr=3; play_sample(al_fx[0],50,200,1000,0); }
   }
  if(boss1.state==1)
   {
    boss1.x++;
    if(synf) { boss1.actfr++; if(boss1.actfr==9) boss1.state=2; }
    if(boss1.actfr<=7) draw_sprite(buffer,boss1.frame[boss1.actfr],boss1.x,boss1.y);
   }

  // Collisioni Giocatore con boss_bomb
  if(player.invis==0 && !player.boom)
   {
    for(int i=0;i<6;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player.x,player.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives--;
          player.actfr=3; player.boom=true;
         }
   }
  if(player.invis==0 && !player.boom)
   {
    if(boss1.state==1 && boss1.actfr<=7)       
     if(hitTest(player.frame[1],boss1.frame[boss1.actfr],player.x,player.y,boss1.x,boss1.y))
      {
       play_sample(pl_fx[1],120,150,1000,0);
       lives--;
       player.actfr=3; player.boom=true;
      }
   }
  // Collisioni boss con proiettile
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=24) boss.angsp=0.04;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=3000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=24) boss.sp=2;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=3000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }
  // Collisioni boss extra con proiettile     
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss1.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss1.frame[boss1.actfr],bullet[i].x,bullet[i].y,boss1.x,boss1.y))
        {
         boss1.hits--; score+=4;
         if(boss1.hits<0) boss1.hits=0;
         if(boss1.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss1.hitted=true;
         boss1.actfr=1;
         if(boss1.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss1.dead=true;
           boss1.boom=true;
           boss1.actfr=2;
           score+=500;
          }
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss1.frame[boss1.actfr],bullet[i].x,bullet[i].y,boss1.x,boss1.y))
        {
         boss1.hits--; score+=4;
         if(boss1.hits<0) boss1.hits=0;
         if(boss1.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss1.hitted=true;
         boss1.actfr=1;
         if(boss1.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss1.dead=true;
           boss1.boom=true;
           boss1.actfr=2;
           score+=500;
          }
         RestoreBullet(i);
        }
      }

  // Collisioni Giocatore 2 con boss_bomb
  if(player2.invis==0 && !player2.boom)
   {
    for(int i=0;i<6;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player2.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player2.x,player2.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives2--;
          player2.actfr=3; player2.boom=true;
         }
   }
  if(player2.invis==0 && !player2.boom)
   {
    if(boss1.state==1 && boss1.actfr<=7)       
     if(hitTest(player2.frame[1],boss1.frame[boss1.actfr],player2.x,player2.y,boss1.x,boss1.y))
      {
       play_sample(pl_fx[1],120,150,1000,0);
       lives2--;
       player2.actfr=3; player2.boom=true;
      }
   }
  // Collisioni boss con proiettile (giocatore 2)
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=24) boss.angsp=0.04;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=3000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=24) boss.sp=2;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=3000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
  // Collisioni boss extra con proiettile (giocatore 2)    
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss1.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss1.frame[boss1.actfr],bullet2[i].x,bullet2[i].y,boss1.x,boss1.y))
        {
         boss1.hits--; score2+=4;
         if(boss1.hits<0) boss1.hits=0;
         if(boss1.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss1.hitted=true;
         boss1.actfr=1;
         if(boss1.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss1.dead=true;
           boss1.boom=true;
           boss1.actfr=2;
           score2+=500;
          }
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss1.frame[boss1.actfr],bullet2[i].x,bullet2[i].y,boss1.x,boss1.y))
        {
         boss1.hits--; score2+=4;
         if(boss1.hits<0) boss1.hits=0;
         if(boss1.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss1.hitted=true;
         boss1.actfr=1;
         if(boss1.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss1.dead=true;
           boss1.boom=true;
           boss1.actfr=2;
           score2+=500;
          }
         RestoreBullet2(i);
        }
      }
  return false;
 }

bool Boss3()
 {
  boss.aux++; 	
  // Boss start
  if(boss.state==0)
   {
    rotate_scaled_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y,0,boss.aux); 
    if(boss.aux%boss.sp==0) boss.y+=boss.dy;
    boss.aux+=1000;
    if(boss.aux>=65536) { boss.state=1; boss.aux=0; }
    return false;
   }

  // Fuoco
  for(int i=0;i<4;i++)
   {
    if(boss_bomb[i].fired)
     {
      draw_sprite(buffer,boss_bomb[i].frame[Random(1)],boss_bomb[i].x,boss_bomb[i].y);
      boss_bomb[i].y+=boss_bomb[i].sp;
      if(boss_bomb[i].y>200) boss_bomb[i].fired=false;
     }   	
    if(!boss_bomb[i].fired)
     {
      boss_bomb[i].x=boss.x+15; boss_bomb[i].y=boss.y+15+i;
      boss_bomb[i].fired=true;  boss_bomb[i].sp=2;
     }
   }
  // Colpo di coda
  if(boss1.attack==0 && boss1.x==player.x || boss1.attack==0 && boss1.x==player2.x)
   {
   	boss1.sp=boss2.sp=boss3.sp=boss4.sp=0;
   	boss1.attack=1;
   }
  // Boss
  boss.x=(int)(100*sin(boss.ang));
  boss.x+=140; boss.y=45;
  boss.ang+=boss.angsp; if(boss.ang>=360) boss.ang=0;    
  if(syn) { boss.actfr++; boss.actfr=boss.actfr%3; }
  if(boss.hitted) { boss.actfr=3; if(synff) boss.hitted=false; }
  draw_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y);
  // Boss extra
  if(!boss1.boom && boss1.state==0)
   {
    boss1.x=boss.x+25; boss1.y=boss.y+30;
    boss1.x+=(int)(4*sin(boss1.ang));
    boss1.ang+=boss1.angsp; if(boss1.ang>=360) boss1.ang=0;
    if(boss1.attack==1) { boss1.y+=1*boss1.sp; boss1.sp+=2; }
    if(boss1.attack==2) { boss1.y+=1*boss1.sp; boss1.sp-=2; }
    draw_sprite(buffer,boss1.frame[boss1.actfr],boss1.x,boss1.y);
    
    boss2.x=boss.x+25; boss2.y=boss.y+40;
    boss2.x+=(int)(8*sin(boss2.ang));
    boss2.ang+=boss2.angsp; if(boss2.ang>=360) boss2.ang=0;
    if(boss1.attack==1) { boss2.y+=1*boss2.sp; boss2.sp+=3; }
    if(boss1.attack==2) { boss2.y+=1*boss2.sp; boss2.sp-=3; }
    draw_sprite(buffer,boss2.frame[boss2.actfr],boss2.x,boss2.y);
    
    boss3.x=boss.x+25; boss3.y=boss.y+50;
    boss3.x+=(int)(12*sin(boss3.ang));
    boss3.ang+=boss3.angsp; if(boss3.ang>=360) boss3.ang=0;
    if(boss1.attack==1) { boss3.y+=1*boss3.sp; boss3.sp+=4; }
    if(boss1.attack==2) { boss3.y+=1*boss3.sp; boss3.sp-=4; }
    draw_sprite(buffer,boss3.frame[boss3.actfr],boss3.x,boss3.y);
    
    boss4.x=boss.x+25; boss4.y=boss.y+60;
    boss4.x+=(int)(16*sin(boss3.ang));
    boss4.ang+=boss4.angsp; if(boss4.ang>=360) boss4.ang=0;
    if(boss1.attack==1) { boss4.y+=1*boss4.sp; boss4.sp+=5; }
    if(boss1.attack==2) { boss4.y+=1*boss4.sp; boss4.sp-=5; }
    draw_sprite(buffer,boss4.frame[boss4.actfr],boss4.x,boss4.y);
    if(boss4.y>=195) boss1.attack=2;
    if(boss4.sp<0) boss1.attack=0;
   }

  // Collisioni Giocatore con boss_bomb e boss4
  if(player.invis==0 && !player.boom)
   {
    for(int i=0;i<6;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player.x,player.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives--;
          player.actfr=3; player.boom=true;
         }
   }
  if(player.invis==0 && !player.boom)
   {
    if(boss1.state==1 && boss1.actfr<=7)       
     if(hitTest(player.frame[1],boss1.frame[boss1.actfr],player.x,player.y,boss1.x,boss1.y))
      {
       play_sample(pl_fx[1],120,150,1000,0);
       lives--;
       player.actfr=3; player.boom=true;
      }
   }
  if(player.invis==0 && !player.boom)
   {
    if(boss1.attack>0) 
     if(hitTest(player.frame[1],boss4.frame[boss4.actfr],player.x,player.y,boss4.x,boss4.y))
      {
       play_sample(pl_fx[1],120,150,1000,0);
       lives--;
       player.actfr=3; player.boom=true;
      }
   }   
  // Collisioni boss con proiettile
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=36) boss.angsp=0.04;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=5000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=36) boss.angsp=0.04;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=5000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }
  // Collisioni boss extra con proiettile     
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss1.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss1.frame[boss1.actfr],bullet[i].x,bullet[i].y,boss1.x,boss1.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss1.frame[boss1.actfr],bullet[i].x,bullet[i].y,boss1.x,boss1.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss2.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss2.frame[boss2.actfr],bullet[i].x,bullet[i].y,boss2.x,boss2.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss2.frame[boss2.actfr],bullet[i].x,bullet[i].y,boss2.x,boss2.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss3.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss3.frame[boss3.actfr],bullet[i].x,bullet[i].y,boss3.x,boss3.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss3.frame[boss3.actfr],bullet[i].x,bullet[i].y,boss3.x,boss3.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss4.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss4.frame[boss4.actfr],bullet[i].x,bullet[i].y,boss4.x,boss4.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss4.frame[boss4.actfr],bullet[i].x,bullet[i].y,boss4.x,boss4.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet(i);
        }
      }
  // Collisioni Giocatore 2 con boss_bomb e boss4
  if(player2.invis==0 && !player2.boom)
   {
    for(int i=0;i<6;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player2.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player2.x,player2.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives2--;
          player2.actfr=3; player2.boom=true;
         }
   }
  if(player2.invis==0 && !player2.boom)
   {
    if(hitTestFast(player2.frame[1],boss.frame[boss.actfr],player2.x,player2.y,boss.x,boss.y))
     {
      play_sample(pl_fx[1],120,150,1000,0);
      lives2--;
      player2.actfr=3; player2.boom=true;
     }
   }
  if(player2.invis==0 && !player2.boom)
   {
    if(boss1.attack>0) 
     if(hitTest(player2.frame[1],boss4.frame[boss4.actfr],player2.x,player2.y,boss4.x,boss4.y))
      {
       play_sample(pl_fx[1],120,150,1000,0);
       lives2--;
       player2.actfr=3; player2.boom=true;
      }
   }
  // Collisioni boss con proiettile (giocatore 2)
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=36) boss.angsp=0.04;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=5000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=36) boss.angsp=0.04;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=5000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
  // Collisioni boss extra con proiettile (giocatore 2)
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss1.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss1.frame[boss1.actfr],bullet2[i].x,bullet2[i].y,boss1.x,boss1.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss1.frame[boss1.actfr],bullet2[i].x,bullet2[i].y,boss1.x,boss1.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss2.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss2.frame[boss2.actfr],bullet2[i].x,bullet2[i].y,boss2.x,boss2.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss2.frame[boss2.actfr],bullet2[i].x,bullet2[i].y,boss2.x,boss2.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss3.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss3.frame[boss3.actfr],bullet2[i].x,bullet2[i].y,boss3.x,boss3.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss3.frame[boss3.actfr],bullet2[i].x,bullet2[i].y,boss3.x,boss3.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss4.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss4.frame[boss4.actfr],bullet2[i].x,bullet2[i].y,boss4.x,boss4.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss4.frame[boss4.actfr],bullet2[i].x,bullet2[i].y,boss4.x,boss4.y))
        {
         play_sample(al_fx[1],50,100,1000,0);
         RestoreBullet2(i);
        }
      }
  return false;
 }

bool Boss4()
 {
  boss.aux++; 	
  // Boss start
  if(boss.state==0)
   {
    rotate_scaled_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y,0,boss.aux); 
    if(boss.aux%boss.sp==0) boss.y+=boss.dy;
    boss.aux+=1000;
    if(boss.aux>=65536) { boss.state=1; boss.aux=0; }
    return false;
   }

  // Proiettili
  if(boss_bomb[1].fired)
   {
    draw_sprite(buffer,boss_bomb[1].frame[boss_bomb[1].actfr],boss_bomb[1].x,boss_bomb[1].y);
    draw_sprite(buffer,boss_bomb[2].frame[boss_bomb[2].actfr],boss_bomb[2].x,boss_bomb[2].y);
    draw_sprite(buffer,boss_bomb[3].frame[boss_bomb[3].actfr],boss_bomb[3].x,boss_bomb[3].y);
    draw_sprite(buffer,boss_bomb[4].frame[boss_bomb[4].actfr],boss_bomb[4].x,boss_bomb[4].y);
    draw_sprite(buffer,boss_bomb[5].frame[boss_bomb[5].actfr],boss_bomb[5].x,boss_bomb[5].y);
    boss_bomb[1].y+=2; boss_bomb[2].y+=2; boss_bomb[3].y+=2; boss_bomb[4].y+=2; boss_bomb[5].y+=2;
    boss_bomb[2].x++; boss_bomb[3].x+=2; boss_bomb[4].x--; boss_bomb[5].x-=2;
    if(boss_bomb[1].y>220) { boss_bomb[1].fired=false; boss_bomb[2].fired=false; boss_bomb[3].fired=false; boss_bomb[4].fired=false; boss_bomb[5].fired=false; }
   }
  if(boss.y%31==0 && !boss_bomb[1].fired)
   {
    boss_bomb[1].x=boss.x+30; boss_bomb[1].y=boss.y+20; boss_bomb[1].fired=true;
    boss_bomb[2].x=boss.x+30; boss_bomb[2].y=boss.y+20; boss_bomb[2].fired=true;
    boss_bomb[3].x=boss.x+30; boss_bomb[3].y=boss.y+20; boss_bomb[3].fired=true;
    boss_bomb[4].x=boss.x+30; boss_bomb[4].y=boss.y+20; boss_bomb[4].fired=true;
    boss_bomb[5].x=boss.x+30; boss_bomb[5].y=boss.y+20; boss_bomb[5].fired=true;
   }

  // Missile
  if(boss_bomb[0].fired)
   {
    draw_sprite(buffer,boss_bomb[0].frame[boss_bomb[0].actfr],boss_bomb[0].x,boss_bomb[0].y);
    boss_bomb[0].y+=3;
    if(boss_bomb[0].y>202) boss_bomb[0].fired=false;
   }
  if(boss.x%30==0 && !boss_bomb[0].fired)
   { boss_bomb[0].x=boss.x+30; boss_bomb[0].y=boss.y+20; boss_bomb[0].fired=true; }

  // Boss
  if(boss.aux%boss.sp==0)
   {
    boss.y+=boss.dy; boss.x+=boss.dx; 
    if(boss.y>=165) boss.dy*=-1; if(boss.y<=9) boss.dy*=-1;
    if(boss.x>=244) boss.dx*=-1; if(boss.x<=0)  boss.dx*=-1;
   }
  if(syn) { boss.actfr++; boss.actfr=boss.actfr%2; }
  if(boss.hitted) { boss.actfr=2; if(synff) boss.hitted=false; }
  draw_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y);

  // Collisioni Giocatore con boss_bomb
  if(player.invis==0 && !player.boom)
   {
    for(int i=0;i<6;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player.x,player.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives--;
          player.actfr=3; player.boom=true;
         }
   }
  if(player.invis==0 && !player.boom)
   {
    if(hitTestFast(player.frame[1],boss.frame[boss.actfr],player.x,player.y,boss.x,boss.y))
     {
      play_sample(pl_fx[1],120,150,1000,0);
      lives--;
      player.actfr=3; player.boom=true;
     }
   }

  // Collisioni boss con proiettile
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=48) boss.sp=1;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=8000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=48) boss.sp=1;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=8000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }

  // Collisioni Giocatore 2 con boss_bomb
  if(player2.invis==0 && !player2.boom)
   {
    for(int i=0;i<6;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player2.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player2.x,player2.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives2--;
          player2.actfr=3; player2.boom=true;
         }
   }
  if(player2.invis==0 && !player2.boom)
   {
    if(hitTestFast(player2.frame[1],boss.frame[boss.actfr],player2.x,player2.y,boss.x,boss.y))
     {
      play_sample(pl_fx[1],120,150,1000,0);
      lives2--;
      player2.actfr=3; player2.boom=true;
     }
   }

  // Collisioni boss con proiettile (giocatore 2)
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=48) boss.sp=1;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=8000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=48) boss.sp=1;
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=8000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
  return false;
 }

bool Boss5()
 {
  boss.aux++; 	
  // Boss start
  if(boss.state==0)
   {
    rotate_scaled_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y,0,boss.aux); 
    if(boss.aux%boss.sp==0) boss.y+=boss.dy;
    boss.aux+=1000;
    if(boss.aux>=65536) { boss.state=1; boss.aux=0; }
    return false;
   }

  // Proiettili 1
  if(boss_bomb[0].fired)
   {
   	draw_sprite(buffer,boss_bomb[0].frame[boss_bomb[0].actfr],boss_bomb[0].x,boss_bomb[0].y);
    draw_sprite(buffer,boss_bomb[1].frame[boss_bomb[1].actfr],boss_bomb[1].x,boss_bomb[1].y);
    draw_sprite(buffer,boss_bomb[2].frame[boss_bomb[2].actfr],boss_bomb[2].x,boss_bomb[2].y);
    boss_bomb[0].y+=3; boss_bomb[1].y+=3; boss_bomb[2].y+=3;
    boss_bomb[0].x++; boss_bomb[2].x--;
    if(boss_bomb[0].y>220) { boss_bomb[0].fired=false; boss_bomb[1].fired=false; boss_bomb[2].fired=false; }
   }
  if(boss.y%28==0 && !boss_bomb[0].fired)
   {
   	boss_bomb[0].x=boss.x+30; boss_bomb[0].y=boss.y+20; boss_bomb[0].fired=true;
    boss_bomb[1].x=boss.x+30; boss_bomb[1].y=boss.y+20; boss_bomb[1].fired=true;
    boss_bomb[2].x=boss.x+30; boss_bomb[2].y=boss.y+20; boss_bomb[2].fired=true;
   }

  // Proiettili 2
  if(boss_bomb[3].fired)
   {
    draw_sprite(buffer,boss_bomb[3].frame[boss_bomb[3].actfr],boss_bomb[3].x,boss_bomb[3].y);
    draw_sprite(buffer,boss_bomb[4].frame[boss_bomb[4].actfr],boss_bomb[4].x,boss_bomb[4].y);
    draw_sprite(buffer,boss_bomb[5].frame[boss_bomb[5].actfr],boss_bomb[5].x,boss_bomb[5].y);
    boss_bomb[3].y+=2; boss_bomb[4].y+=2; boss_bomb[5].y+=2;
    boss_bomb[3].x++; boss_bomb[5].x--;
    if(boss_bomb[3].y>220) { boss_bomb[3].fired=false; boss_bomb[4].fired=false; boss_bomb[5].fired=false; }
   }
  if(boss.y%26==0 && !boss_bomb[3].fired)
   {
    boss_bomb[3].x=boss.x+60; boss_bomb[3].y=boss.y+20; boss_bomb[3].fired=true;
    boss_bomb[4].x=boss.x+60; boss_bomb[4].y=boss.y+20; boss_bomb[4].fired=true;
    boss_bomb[5].x=boss.x+60; boss_bomb[5].y=boss.y+20; boss_bomb[5].fired=true;
   }

  // Laser
  for(int i=6;i<12;i++)
   {
    if(boss_bomb[i].fired)
     {
      draw_sprite(buffer,boss_bomb[i].frame[boss_bomb[i].actfr],boss_bomb[i].x,boss_bomb[i].y);
      boss_bomb[i].y+=boss_bomb[i].sp;
      if(boss_bomb[i].y>206) boss_bomb[i].fired=false;
     }   	
    if(!boss_bomb[i].fired && Random(30)==0)
     {
      boss_bomb[i].x=boss.x+36; boss_bomb[i].y=boss.y+15;
      boss_bomb[i].fired=true;  boss_bomb[i].sp=Random(2)+1;
     }
   }

  // Boss
  if(boss.aux%boss.sp==0)
   {
    boss.y+=boss.dy;
    if(boss.y>=120) boss.dy*=-1; if(boss.y<=9) boss.dy*=-1;
   }
  boss.x=(int)(100*sin(boss.ang));
  boss.x+=105;// boss.y=45;
  boss.ang+=boss.angsp; if(boss.ang>=360) boss.ang=0;    
   
  if(syn) { boss.actfr++; boss.actfr=boss.actfr%2; }
  if(boss.hitted) { boss.actfr=2; if(synff) boss.hitted=false; }
  draw_sprite(buffer,boss.frame[boss.actfr],boss.x,boss.y);

  // Collisioni Giocatore con boss_bomb
  if(player.invis==0 && !player.boom)
   {
    for(int i=0;i<11;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player.x,player.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives--;
          player.actfr=3; player.boom=true;
         }
   }

  // Collisioni boss con proiettile
  for(int i=0;i<mbul;i++)
   if(bullet[i].fired) 
    if(!boss.dead && bullet[i].fired)
     if(weapon==3)
      {
       if(hitTestFast(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=60) { boss.sp=1; boss.angsp=0.04; }
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=10000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }
     else
      {
       if(hitTest(bullet[i].frame[bullet[i].actfr],boss.frame[boss.actfr],bullet[i].x,bullet[i].y,boss.x,boss.y))
        {
         boss.hits--; score+=5;
         if(boss.hits<=60) { boss.sp=1; boss.angsp=0.04; }
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score+=10000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet(i);
        }
      }

  // Collisioni Giocatore 2 con boss_bomb
  if(player2.invis==0 && !player2.boom)
   {
    for(int i=0;i<11;i++) 
     if(boss_bomb[i].fired) 
      if(hitTest(player2.frame[1],boss_bomb[i].frame[boss_bomb[i].actfr],player2.x,player2.y,boss_bomb[i].x,boss_bomb[i].y))
         {
          play_sample(pl_fx[1],120,150,1000,0);
          boss_bomb[i].fired=false;
          lives2--;
          player2.actfr=3; player2.boom=true;
         }
   }
  // Collisioni boss con proiettile (Giocatore 2)
  for(int i=0;i<mbul2;i++)
   if(bullet2[i].fired) 
    if(!boss.dead && bullet2[i].fired)
     if(weapon2==3)
      {
       if(hitTestFast(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=60) { boss.sp=1; boss.angsp=0.04; }
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=10000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
     else
      {
       if(hitTest(bullet2[i].frame[bullet2[i].actfr],boss.frame[boss.actfr],bullet2[i].x,bullet2[i].y,boss.x,boss.y))
        {
         boss.hits--; score2+=5;
         if(boss.hits<=60) { boss.sp=1; boss.angsp=0.04; }
         if(boss.hits<0) boss.hits=0;
         if(boss.hits>0) play_sample(al_fx[1],50,100,1000,0);
         boss.hitted=true;
         if(boss.hits==0)
          {
           play_sample(al_fx[0],50,200,1000,0);
           boss.dead=true;
           boss.boom=true;
           score2+=10000;
           exp_n=0; return true; // Boss eliminato
          }
         RestoreBullet2(i);
        }
      }
  return false;
 }

void Intro()
 {
  fade_out(5);
  clear_to_color(bg,0);
  textprintf_ex(bg,font,0,40,6,bgcol," Year 2078...");
  textprintf_ex(bg,font,0,56,6,bgcol," Near the earth, hided by a force");
  textprintf_ex(bg,font,0,64,6,bgcol," field, a new danger for the whole");
  textprintf_ex(bg,font,0,72,6,bgcol," umanity begin ...");
  ToScreen(bg);
  fade_in(pal,2);
  wait(6000);
  LoadData(-2);
  ToScreen(bg);
  play_midi(bgsound,1);
  fade_in(pal,2);

  intro[0].x=-50; intro[0].y=190; intro[0].actfr=0;
  for(int i=0;i<400;i++)
   {
   	Sync();
   	draw_sprite(buffer,bg,0,0);
   	if(i%2==0) intro[0].x++;
   	if(i%5==0) { intro[0].actfr++; if(intro[0].actfr>4) intro[0].actfr=0; }
    draw_sprite_h_flip(buffer,intro[0].frame[intro[0].actfr],intro[0].x,intro[0].y);
    draw_sprite(buffer,intro[1].frame[0],70,221);
    ToScreen(buffer);
   }
  for(int i=0;i<200;i++)
   {
   	Sync();
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[5],intro[0].x,intro[0].y);
    if(i>50 && i<=180)
     {
      rectfill(buffer,18,147,22+22*8,160,7);
      textprintf_ex(buffer,font,20,150,1,7,"Destroy this planet...");
     }
    if(i>180)
     {
      rectfill(buffer,148,147,152+5*8,160,7);
      textprintf_ex(buffer,font,150,150,1,7,"Fire!");
     }
    ToScreen(buffer);
   }
  intro[3].x=324; intro[3].y=178; intro[3].aux=0;
  play_sample(pl_fx[0],200,150,1000,0);
  for(int i=0;i<400;i++) // Missile
   {
   	Sync();
   	if(i%2==0) intro[3].x--;
   	if(i%3==0) intro[3].y--;
   	intro[3].aux+=200;
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[5],intro[0].x,intro[0].y);
    if(i<320) rotate_scaled_sprite(buffer,intro[3].frame[0],intro[3].x,intro[3].y,0,65536-intro[3].aux);
    draw_sprite(buffer,intro[2].frame[0],250,70);
    if(i<100)
     {
      rectfill(buffer,148,147,152+5*8,160,7);
      textprintf_ex(buffer,font,150,150,1,7,"Fire!");
     }
    ToScreen(buffer);
   }
  intro[4].actfr=1;
  play_sample(pl_fx[1],200,150,1000,0);
  for(int i=0;i<200;i++) // Boom
   {
   	Sync();
   	if(i%8==0) intro[4].actfr++;
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[5],intro[0].x,intro[0].y);
    draw_sprite(buffer,intro[4].frame[0],139,53);
    if(intro[4].actfr<=7) draw_sprite(buffer,intro[4].frame[intro[4].actfr],139,53);
    if(i>120)
     {
     	rectfill(buffer,18,147,22+25*8,168,7);
      textprintf_ex(buffer,font,20,150,1,7,"And now send the fighters");
      textprintf_ex(buffer,font,20,158,1,7,"for final attack...");
     }
    ToScreen(buffer);
   }
  intro[3].x=335; intro[3].y=150; intro[3].aux=0;
  for(int i=0;i<240;i++) // Caccia
   {
   	Sync();
   	if(i==20) play_sample(pl_fx[2],200,150,1000,0);
   	if(intro[3].x>250) { if(i%2==0) intro[3].x--; }
   	else intro[3].x--;
   	if(i%3==0) intro[3].y--;
   	intro[3].aux+=250;
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[5],intro[0].x,intro[0].y);
    draw_sprite(buffer,intro[4].frame[0],139,53);
    if(i<320) rotate_scaled_sprite(buffer,intro[3].frame[1],intro[3].x,intro[3].y,0,65536-intro[3].aux);
    draw_sprite(buffer,intro[2].frame[0],250,70);
    if(i<150)
     {
     	rectfill(buffer,18,147,22+25*8,168,7);
      textprintf_ex(buffer,font,20,150,1,7,"And now send the fighters");
      textprintf_ex(buffer,font,20,158,1,7,"for final attack...");
     }
    ToScreen(buffer);
   }  
  for(int i=0;i<280;i++) // Esultanza
   {
   	Sync();
   	draw_sprite(buffer,bg,0,0);
   	if(i>70) draw_sprite_h_flip(buffer,intro[0].frame[6],intro[0].x,intro[0].y);
   	else draw_sprite_h_flip(buffer,intro[0].frame[5],intro[0].x,intro[0].y);
    draw_sprite(buffer,intro[4].frame[0],139,53);
    if(i>70)
     {
     	rectfill(buffer,18,147,22+33*8,160,7);
      textprintf_ex(buffer,font,20,150,1,7,"Finally I'll conquer this planet!");
     }
    ToScreen(buffer);
   }  
  fade_out(5);
  clear_to_color(bg,1);
  textprintf_ex(bg,font,0,40,2,1," ... but a pilot with his spaceship,");
  textprintf_ex(bg,font,0,48,2,1," can save the earth and the umanity?");
  textprintf_ex(bg,font,0,56,2,1," ");
  textprintf_ex(bg,font,0,64,2,1," ");
  ToScreen(bg);
  fade_in(pal,2);
  wait(6000);
  stop_midi();

  // Ritorna ai titoli
  fade_out(4);
  LoadData(0);
  ToScreen(bg);
  fade_in(pal,2);
  Credits();
 }

void End()
 {
  fade_out(5);
  clear_to_color(bg,1);
  if(lives>1)
   {
    textprintf_ex(bg,font,0,40 ,3,1,"Final bonus Player 1");
    textprintf_ex(bg,font,0,64 ,3,1," - Money %d x 2 = %d",money,money*2);
    textprintf_ex(bg,font,0,72 ,3,1," - Lives %d x 1000 = %d",lives,lives*1000);
    textprintf_ex(bg,font,0,88 ,3,1," Score: %d",score);
    textprintf_ex(bg,font,0,96 ,3,1," Bonus: %d",money*2+lives*1000);
    score+=money*2+lives*1000;
    textprintf_ex(bg,font,0,104,3,1," Final score: %d",score);
   }
  if(NPLAYERS==2 && lives2>1)
   {
   	textprintf_ex(bg,font,0,128,3,1,"Final bonus Player 2");
    textprintf_ex(bg,font,0,152,3,1," - Money %d x 2 = %d",money2,money2*2);
    textprintf_ex(bg,font,0,160,3,1," - Lives %d x 1000 = %d",lives2,lives2*1000);
    textprintf_ex(bg,font,0,176,3,1," Score: %d",score2);
    textprintf_ex(bg,font,0,184,3,1," Bonus: %d",money2*2+lives2*1000);
    score2+=money2*2+lives2*1000;
    textprintf_ex(bg,font,0,192,3,1," Final score: %d",score2);
   }
  // Finale
  ToScreen(bg);
  fade_in(pal,2);
  wait(12000);
  LoadData(-3);
  ToScreen(bg);
  fade_in(pal,2);

  intro[0].x=-50; intro[0].y=190; intro[0].actfr=0;
  for(int i=0;i<560;i++)
   {
   	Sync();
   	draw_sprite(buffer,bg,0,0);
   	if(i%3==0) intro[0].x++;
   	if(i%7==0) { intro[0].actfr++; if(intro[0].actfr>4) intro[0].actfr=0; }
    draw_sprite_h_flip(buffer,intro[0].frame[intro[0].actfr],intro[0].x,intro[0].y);
    draw_sprite(buffer,intro[1].frame[0],70,221);
    ToScreen(buffer);
   }
  for(int i=0;i<200;i++) // Ferito
   {
   	Sync();
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[7],intro[0].x,intro[0].y);
    draw_sprite(buffer,intro[1].frame[0],70,221);
   	rectfill(buffer,48,147,52+14*8,160,8);
    textprintf_ex(buffer,font,50,150,1,8,"Aaaaaaaargh!!!");
    ToScreen(buffer);
   }
  for(int i=0;i<200;i++) // Morto
   {
   	Sync();
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[8],intro[0].x+4,intro[0].y+34);
    draw_sprite(buffer,intro[1].frame[0],70,221);
    ToScreen(buffer);
   }
  intro[5].x=170; intro[5].y=222; // Spunta testa
  for(int i=0;i<100;i++)
   {
   	Sync();
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[9],intro[0].x+4,intro[0].y+34);
    draw_sprite_h_flip(buffer,intro[5].frame[0],intro[5].x,intro[5].y);
    draw_sprite(buffer,intro[1].frame[0],70,221);
    ToScreen(buffer);
   }
  intro[5].actfr=0; // Testa cammina
  for(int i=0;i<430;i++)
   {
   	Sync();
   	if(i%3==0)  intro[5].x++;
   	if(i<250)  { if(i%16==0) intro[5].y++; } else { if(i%8==0) intro[5].y++; }
   	if(i%8==0) { intro[5].actfr++; if(intro[5].actfr>1) intro[5].actfr=0; }
   	draw_sprite(buffer,bg,0,0);
    draw_sprite_h_flip(buffer,intro[0].frame[9],intro[0].x+4,intro[0].y+34);
    draw_sprite_h_flip(buffer,intro[5].frame[intro[5].actfr],intro[5].x,intro[5].y);
    draw_sprite(buffer,intro[1].frame[0],70,221);
    ToScreen(buffer);
   }
  int sca; // Boom
  for(int j=0;j<20;j++)
   {
    intro[4].x=Random(260)-30; intro[4].y=Random(160)-20; intro[4].actfr=1;
    sca=Random(2)+1;
    play_sample(pl_fx[1],120,150,1000,0);
    for(int i=0;i<45;i++)
     {
   	  Sync();
   	  if(i%8==0) intro[4].actfr++;
   	  draw_sprite(buffer,bg,0,0);
      draw_sprite_h_flip(buffer,intro[0].frame[9],intro[0].x+4,intro[0].y+34);
      draw_sprite(buffer,intro[1].frame[0],70,221);
      if(intro[4].actfr<=7) rotate_scaled_sprite(buffer,intro[4].frame[intro[4].actfr],intro[4].x,intro[4].y,0,65536*sca);
      ToScreen(buffer);
     }
   }
  fade_out(5);
  clear_to_color(bg,1);
  textprintf_ex(bg,font,0,40,2,1," Congratulation! You have saved the");
  textprintf_ex(bg,font,0,48,2,1," world, but ... is this the end ... ?");
  ToScreen(bg);
  fade_in(pal,2);
  wait(6000);
  fade_out(5);
  clear_to_color(bg,1);
  if(SKILL==1)
   {
    textprintf_ex(bg,font,0,40,2,1," ... press k in the title screen when");
    textprintf_ex(bg,font,0,48,2,1," cursor its over S..R. ..M. ??? ;-)");
   }
  if(SKILL==2)
   {
    textprintf_ex(bg,font,0,40,2,1," ... press v+u in the title screen when");
    textprintf_ex(bg,font,0,48,2,1," cursor its over .TA.T .... ??? ;-))))");
   }
  if(SKILL==3)
   {
    textprintf_ex(bg,font,0,40,2,1,"Press k in the title screen when cursor");
    textprintf_ex(bg,font,0,48,2,1,"its over START GAME (money bonus)");
    textprintf_ex(bg,font,0,64,2,1,"Press v+u in the title screen when");
    textprintf_ex(bg,font,0,72,2,1,"cursor its over START GAME (super bonus)");
    textprintf_ex(bg,font,0,88,2,1,"Press x in the title screen when cursor");
    textprintf_ex(bg,font,0,96,2,1,"its over START GAME to remove cheats");
   }
  ToScreen(bg);
  fade_in(pal,2);
  wait(4000);   	
  gameover=true;
 }
